#include "Logging.h"
#include <fstream>
#include <iostream>

int g_cntWrn= 0;
int g_cntErr= 0;

// Log file. All messages passed to 'printLogMsg()' are dumped into this file.
std::ofstream logFile;

void createLogFile( const std::string& logFilePath)
{
	logFile.open( (logFilePath+ "TranslatorLog.txt").c_str());
}

void closeLogFile()
{
	if ( logFile.is_open())
		logFile.close();
}

void printLogMsg( const std::string& logMsg)
{
	std::cout << logMsg << std::endl;
	if ( logFile.is_open())
		logFile << logMsg << std::endl;
}

void logRule( const std::string& type, const std::string& name, int depth)
{
	std::string logMsg;
	for( int i=0; i< depth; ++i) logMsg+=  "\t";
	logMsg+= type + ": " + name;
	printLogMsg( logMsg);
}

void printWarning( const std::string& wrnMsg)
{
	++g_cntWrn;
	printLogMsg( "WARNING: "+ wrnMsg);
}

void printError( const std::string& errMsg)
{
	++g_cntErr;
	printLogMsg( "ERROR: "+ errMsg);
}