// GREngineDlgDlg.cpp : implementation file
//

#include "stdafx.h"
#include <boost/thread/thread.hpp>
#include "GREngineDlgDlg.h"
#include "GRThread.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGREngineDlgDlg dialog
string CGREngineDlgDlg::outputMsg = "";

CGREngineDlgDlg::CGREngineDlgDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGREngineDlgDlg::IDD, pParent),
  m_notify(0),
  m_prg(0),
  m_thrd(0),
  cfgPath(""),
  m_finished(true),
  processPos(1)
{
	//{{AFX_DATA_INIT(CGREngineDlgDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDI_GREICON);
}

CGREngineDlgDlg::CGREngineDlgDlg(const string &filePath, CWnd* pParent /*=NULL*/)   
	: CDialog(CGREngineDlgDlg::IDD, pParent),
  m_notify(0),
  m_prg(0),
  m_thrd(0),
  cfgPath(filePath),
  m_finished(true),
  processPos(0)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDI_GREICON);
}

CGREngineDlgDlg::CGREngineDlgDlg(const string &filePath, const vector<string> &inputs, CWnd* pParent /*=NULL*/)
	: CDialog(CGREngineDlgDlg::IDD, pParent),
  m_notify(0),
  m_prg(0),
  m_thrd(0),
  cfgPath(filePath),
  cfgInputs(inputs),
  m_finished(true),
  processPos(0)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDI_GREICON);
}

void CGREngineDlgDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGREngineDlgDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CGREngineDlgDlg, CDialog)
	//{{AFX_MSG_MAP(CGREngineDlgDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
  ON_MESSAGE(SET_PROGRESS,OnProgress)
    ON_MESSAGE(SET_EXECUTERULE,OnExecuteRule)
  ON_MESSAGE(GR_FINISHED,OnFinished)

	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGREngineDlgDlg message handlers

BOOL CGREngineDlgDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	m_maxPrg  = 100;
	m_notify = new Notify(*this, m_maxPrg);

	CWnd *wnd = (CWnd *)GetDlgItem(IDC_STATIC_TXT);
	CString msg = (CString)(cfgPath.c_str()) + 
					"\n is being loaded, please wait ......";
	wnd->SetWindowText(msg);

	m_finished = false;
	m_thrd = new boost::thread(GRThread(cfgPath, cfgInputs, m_notify));

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CGREngineDlgDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CGREngineDlgDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

//=================================
LRESULT CGREngineDlgDlg::OnProgress(WPARAM wp, LPARAM lp)
{
	return 0;
}
//=================================
LRESULT CGREngineDlgDlg::OnExecuteRule(WPARAM wp, LPARAM lp)
{
	m_prg = (CProgressCtrl*) GetDlgItem(IDC_PROGRESS);
	m_prg->SetRange( 0, m_maxPrg);
	if(processPos > m_maxPrg) processPos = 0;
	m_prg->SetPos(processPos);
	processPos += 10;

	CWnd *wnd = (CWnd *)GetDlgItem(IDC_STATIC_TXT);
	wnd->SetWindowText((LPCTSTR)wp);

	return 0;
}

//=================================
LRESULT CGREngineDlgDlg::OnFinished(WPARAM wp, LPARAM lp)
{
	if(!m_notify->m_quit)  //If there is any exception, do not show the progress any more
	{
		m_prg = (CProgressCtrl*) GetDlgItem(IDC_PROGRESS);
		m_prg->SetRange( 0, m_maxPrg);
		while(processPos < m_maxPrg)
		{
			Sleep(50);
			m_prg->StepIt();
			processPos += 5;
		}
	}
//	OnCancel(); 
	if (m_thrd )
	{
		m_notify->m_quit = true;
		m_thrd->join();
	}	
	CDialog::OnCancel();
	
	if(!outputMsg.empty()) 
		AfxMessageBox(CString(outputMsg.c_str()), MB_OK|MB_ICONINFORMATION);
	outputMsg.clear();
	
	return 0;
}

//=================================
void CGREngineDlgDlg::PostNcDestroy() 
{
	delete m_thrd, m_thrd = 0;
	delete m_notify, m_notify = 0;

	CDialog::PostNcDestroy();
	delete this;
}
//=================================
void CGREngineDlgDlg::OnCancel() 
{
 	if (m_thrd )
	{
		m_notify->m_quit = true;
		m_notify->m_cancel = true;
		m_thrd->join();
	}
	
	CDialog::OnCancel();
}
