/*
Copyright (c) Vanderbilt University, 2000-2001
ALL RIGHTS RESERVED
Vanderbilt University disclaims all warranties with regard to this
software, including all implied warranties of merchantability
and fitness.  In no event shall Vanderbilt University be liable for
any special, indirect or consequential damages or any damages
whatsoever resulting from loss of use, data or profits, whether
in an action of contract, negligence or other tortious action,
arising out of or in connection with the use or performance of
this software.
*/


// UdmApp.cpp: implementation of the CUdmApp class.
// This file was automatically generated as UdmApp.cpp
// by UDM Interpreter Wizard on Monday, May 13, 2002 13:45:42

// Tihamr Levendovszky 05-13-02

#include "stdafx.h"
#include <afxdlgs.h> // For CFileDialog
#include "resource.h"

//#include <iostream.h>
#include <atlbase.h>
#include <comdef.h>

#include <time.h>
#include "UdmStatic.h"
#include "UdmDom.h"
#include "UdmGME.h"
#include "UmlExt.h"
#include "UdmUtil.h"

#include "UdmApp.h"
#include "UdmConfig.h"

#include "resource.h"
#include "ConfigurationDlg.h"
#include "GREngineDlgDlg.h"
#include "GRThread.h"

#include <direct.h>

extern void dummy(void); // Dummy function for UDM meta initialization


char* GetRelativeFilename(const char *currentDirectory,const char *absoluteFilename);
bool isSameDrive(const char *currentDirectory,const char *absoluteFilename);

string convertPath(const string &currentPath, const string &absoluteFilename)
{
	string path(absoluteFilename);
	if(!absoluteFilename.empty() && 
		isSameDrive(currentPath.c_str(), absoluteFilename.c_str()))
		path = (string)(GetRelativeFilename(currentPath.c_str(),absoluteFilename.c_str()));

	return path;
}

static string currPath = "";
/*********************************************************************************/
/* Initialization function. The framework calls it before preparing the backend. */
/* Initialize here the settings in the config static object.					 */
/* Return 0 if successful.														 */
/*********************************************************************************/
int CUdmApp::Initialize()
{
	// TODO: Your initialization code comes here...
	return 0;
}

/* 
Remarks to CUdmApp::UdmMain(...):
0.	The p_backend points to an already open backend, and the framework 
	closes it automatically. DO NOT OPEN OR CLOSE IT!
	To commit changes use p_backend->CommitEditSequence().
	To abort changes use p_backend->AbortEditSequence().
	To save changes to a different file use p_backend->SaveAs() or p_backend->CloseAs().

1.	Focus is the currently open model.

2.	The possible values for param (from GME DecoratorLib.h component_startmode_enum):
	GME_MAIN_START			=   0,
	GME_BROWSER_START		=   1,
	GME_CONTEXT_START		=   2,
	GME_EMBEDDED_START		=   3,
	GME_MENU_START			=  16,
	GME_BGCONTEXT_START		=  18,
	GME_ICON_START			=  32,
	METAMODEL_CHECK_SYNTAX	= 101

 3. The framework catches all the exceptions and reports the error in a message box,
	clean up and close the transactions aborting the changes. You can override this 
	behavior by catching udm_exception. Use udm_exception::what() to form an error 
	message.
*/

/***********************************************/
/* Main entry point for Udm-based Interpreter  */
/***********************************************/
//CGREngineDlgDlg* CUdmApp::m_pDialog = 0;

CString CUdmApp::mgaPath = "";

void CUdmApp::UdmMain(
					 Udm::DataNetwork* p_backend,		// Backend pointer(already open!)
					 Udm::Object focusObject,			// Focus object
					 set<Udm::Object> selectedObjects,	// Selected objects
					 long param)						// Parameters
{	
	// TODO: Your Code Comes Here...
//	AfxMessageBox(mgaPath);
/*	char buffer[200];
	_getcwd(buffer, 200);

	if(currPath.empty()) currPath = (string)buffer;
*/
//	try
//	{	
		UMLModelTransformer::RootFolder rf = UMLModelTransformer::RootFolder::Cast(p_backend->GetRootObject());
		const set<UMLModelTransformer::Configurations> &cfgs = rf.Configurations_kind_children();
		if(cfgs.empty()) throw udm_exception("No Configurtion File found.");

		const UMLModelTransformer::Configurations &cfg = *(cfgs.begin());		
		const set<UMLModelTransformer::Configuration> &cfgfiles = cfg.Configuration_kind_children();
		if(cfgs.empty()) throw udm_exception("No Configurtion File found.");

		UMLModelTransformer::Configuration cfgfile = *(cfgfiles.begin());
//		string greate_cfg = cfgfile.ConfigFile();

//Get the full path from the greate_cfg
		string greate_cfg = GReATConfigMeta::getFullPath((string)mgaPath, (string)cfgfile.ConfigFile());
////////////////////////////////////////////////////////////

		if(greate_cfg.empty()) 
			throw udm_exception("This no configuration file specified.");

		const set<UMLModelTransformer::NoPrompt> &noprompts = cfgfile.NoPrompt_children();

		CGREngineDlgDlg *m_pDialog;
		if(!noprompts.empty())
		{
		//directly invoke Grengine
			string str ="Do you want to run GREngine on the configuration file "+greate_cfg+" ?";
			if(AfxMessageBox(str.c_str(),MB_OKCANCEL|MB_ICONINFORMATION)==IDOK) 
			{
				try
				{
					m_pDialog = new CGREngineDlgDlg(greate_cfg);
					m_pDialog->DoModal();
		//			return;
				}
				catch(udm_exception &exc)
				{
	//				AfxMessageBox(CString("Exception: ") + CString(exc.what()));
	//				return;
					throw exc;
				}
			}
		}
		else
		{
			vector<ConfigInfo> cfgInfos;
			getInitialCfgInfos(greate_cfg,cfgfile,cfgInfos);

//			CConfigurationDlg cdlg(&cfgInfos, CString(((string)cfgfile.ConfigFile()).c_str()));
			CConfigurationDlg cdlg(&cfgInfos,(string)cfgfile.ConfigFile());
			if(cdlg.DoModal() == IDCANCEL) return;
		
			vector<string> fileinputs;
			for(vector<ConfigInfo>::iterator i=cfgInfos.begin();i!=cfgInfos.end();++i)
			{
				const ConfigInfo &cfg_info = *i;
				string input = cfg_info.fileId+"=\""+cfg_info.filePath+"\"";
				if(cfg_info.fileMode=="rwc" && !cfg_info.copyPath.empty())
				{
					input = input+";\""+cfg_info.copyPath+"\"";
				}
				fileinputs.push_back(input);
			}
			if(cdlg.m_rungre)
			{
				try
				{
					m_pDialog = new CGREngineDlgDlg(greate_cfg, fileinputs);
					m_pDialog->DoModal();
				}
				catch(udm_exception &exc)
				{
				//	AfxMessageBox(CString("Exception: ") + CString(exc.what()));
				//	return;
					throw exc;
				}
			}
			if(cdlg.m_update) 
			{
				if(updateConfigFile(cfgfile,cfgInfos) && !cdlg.m_rungre) 		
					AfxMessageBox("This configuration file has been updated.", MB_OK|MB_ICONINFORMATION);
			}
			else p_backend->AbortEditSequence();
		}
//	}
/*	catch(udm_exception &e)
	{
		AfxMessageBox(CString("Exception: ")+CString(e.what()));
	}											
*/
}

void CUdmApp::getInitialCfgInfos(const string &greate_cfg, 
								 UMLModelTransformer::Configuration &cfgfile,
								 vector<ConfigInfo> &cfgInfos)
{
	Udm::SmartDataNetwork *sdnConfig = new Udm::SmartDataNetwork(GReATConfig::diagram);
	sdnConfig->OpenExisting(greate_cfg, "GReATConfig.xsd", Udm::CHANGES_LOST_DEFAULT);
	
	GReATConfig::RootFolder cfgrf = GReATConfig::RootFolder::Cast(sdnConfig->GetRootObject());
	set<GReATConfig::UsageInformation> useinfos = cfgrf.UsageInformation_kind_children();
	if(useinfos.empty()) 
		throw udm_exception("No UsageInformation found in "+greate_cfg);

	GReATConfig::UsageInformation useinfo = *(useinfos.begin());
	set<GReATConfig::FileUsage> files = useinfo.FileUsage_kind_children();

	map<string, GReATConfig::InputFile> id2cfg;
	const set<GReATConfig::RuntimeInformation> &runtimeInfos = cfgrf.RuntimeInformation_kind_children();
	if(!runtimeInfos.empty())
	{
		const GReATConfig::RuntimeInformation &runtimeInfo = *(runtimeInfos.begin());
		const set<GReATConfig::InputFile> &inputFiles = runtimeInfo.InputFile_kind_children();
		for(set<GReATConfig::InputFile>::const_iterator j=inputFiles.begin();j!=inputFiles.end();++j)
		{
			const GReATConfig::InputFile &inputFile = *j;
			id2cfg[(string)inputFile.FileID()] = inputFile;
		}
	}

	map<string, UMLModelTransformer::File> id2umt; 
	const set<UMLModelTransformer::FileBind> filebindings=cfgfile.FileBind_kind_children();
	for(set<UMLModelTransformer::FileBind>::const_iterator k=filebindings.begin();k!=filebindings.end();++k)
	{
		const UMLModelTransformer::FileBind &filebinding = *k;
		const UMLModelTransformer::File &file = filebinding.srcFileBind_end();
		const UMLModelTransformer::FileType &filetype = filebinding.dstFileBind_end();
		id2umt[(string)filetype.name()] = file;
	}

	for(set<GReATConfig::FileUsage>::const_iterator i=files.begin();i!=files.end();++i)
	{
		const GReATConfig::FileUsage &file = *i;
		const string &fileId = file.FileID();
		ConfigInfo cfg(fileId,(string)file.MetaName(),(string)file.Mode());
		map<string, UMLModelTransformer::File>::iterator pos1 = id2umt.find(fileId);
		if(pos1!=id2umt.end())
		{
			const UMLModelTransformer::File &umt_file = (*pos1).second;
			cfg.filePath = (string)umt_file.FilePathName();
			cfg.copyPath = (string)umt_file.CopyPathName();
		}
		
		map<string, GReATConfig::InputFile>::iterator pos2 = id2cfg.find(fileId);
		if(pos2!=id2cfg.end()) 
		{
			const GReATConfig::InputFile &greate_file = (*pos2).second;
			if(cfg.filePath.empty()) 
				cfg.filePath = (string)greate_file.FileName();
			if(cfg.copyPath.empty())
				cfg.copyPath = (string)greate_file.CopyName();
		}
		cfgInfos.push_back(cfg);
	}

	sdnConfig->CloseNoUpdate();
	if(sdnConfig)
	{
		delete sdnConfig, sdnConfig = 0;
	}
}

bool CUdmApp::updateConfigFile(UMLModelTransformer::Configuration &cfgfile,
								 vector<ConfigInfo> &cfgInfos)
{
	string cfgFileFullPath = cfgfile.ConfigFile();
	size_t pos = cfgFileFullPath.rfind( "\\");
	if ( pos != string::npos)
		cfgFileFullPath.erase(pos, cfgFileFullPath.length());

/*	const set<UMLModelTransformer::MetaInformation> &minfos = cfgfile.MetaInformation_kind_children();
	if(minfos.empty())
	{
		AfxMessageBox("There is no MetaInformation. Configuration model cannot be updated.");
	}

	const set<UMLModelTransformer::StartRule> &startrules = cfgfile.StartRule_kind_children();
	if(startrules.empty())
	{
		AfxMessageBox("There is no StartRule. Configuration file cannot be updated.");
		return;
	}
*/
	set<UMLModelTransformer::FileType> filetypes = cfgfile.FileType_kind_children();
	if(filetypes.empty())
	{
		AfxMessageBox("There is no FileType. Configuration file cannot be updated.");
		return false;
	}

	for(set<UMLModelTransformer::FileType>::iterator i=filetypes.begin();i!=filetypes.end();++i)
	{
		UMLModelTransformer::FileType filetype = *i;
		const set<UMLModelTransformer::FileBind> &binds = filetype.srcFileBind();
		UMLModelTransformer::File file;
		if(binds.empty())
		{
			file = UMLModelTransformer::File::Create(cfgfile);
			UMLModelTransformer::FileBind newbind = UMLModelTransformer::FileBind::Create(cfgfile);
			newbind.srcFileBind_end() = file;
			newbind.dstFileBind_end() = filetype;
			file.name() = filetype.name();
		}
		else
		{
			const UMLModelTransformer::FileBind &bind = *(binds.begin());
			file = bind.srcFileBind_end();
		}
		
		for(vector<ConfigInfo>::iterator j=cfgInfos.begin();j!=cfgInfos.end();++j)
		{
			const ConfigInfo &cfgInfo = *j;
			if(cfgInfo.fileId == (string)filetype.name())
			{
				file.FilePathName() = convertPath(cfgFileFullPath,cfgInfo.filePath);
				file.CopyPathName() = convertPath(cfgFileFullPath,cfgInfo.copyPath);
				break;
			}
		}
	}
	return true;
}
#ifdef _DEBUG
/*****************************************************/
/* Debug time helper function. If the object has an  */
/* attribute called "name", this function retreives  */
/* it to help you to find it in the model during the */
/* application development.	Usualy every GME Object	 */
/* has a "name" attribute. If an object hapens not	 */
/* to have it,function retreives <no name specified>.*/
/*****************************************************/
string CUdmApp::ExtractName(Udm::Object ob)
{
	Uml::Class cls= ob.type();				
	set<Uml::Attribute> attrs=cls.attributes();		
	
	// Adding parent attributes
	set<Uml::Attribute> aattrs=Uml::AncestorAttributes(cls);
	attrs.insert(aattrs.begin(),aattrs.end());

	for(set<Uml::Attribute>::iterator ai = attrs.begin();ai != attrs.end(); ai++) 
	{
		if(string(ai->type())=="String")
		{
			string str=ai->name();
			if(str=="name")
			{
				string value=ob.getStringAttr(*ai);
				if(value.empty())value="<empty string>";
				return value;
			}			
		}				
	}	
	return string("<no name specified>");
}
#endif