// FileInfoDialog.cpp : implementation file
//

#include "stdafx.h"
#include <afxdlgs.h> 
#include "resource.h"
#include "FileInfoDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


char* GetRelativeFilename(const char *currentDirectory,const char *absoluteFilename);

/////////////////////////////////////////////////////////////////////////////
// CFileInfoDialog dialog


CFileInfoDialog::CFileInfoDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CFileInfoDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFileInfoDialog)
	m_ConfigName = _T("");
	m_UdmName = _T("");
	m_GrName = _T("");
	m_GenName = _T("");
	m_RunCG = FALSE;
	m_RunGRE = FALSE;
	//}}AFX_DATA_INIT

	//m_hIcon = AfxGetApp()->LoadIcon("IDI_COMPICON");

}


void CFileInfoDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFileInfoDialog)
	DDX_Text(pDX, IDC_CONFIG, m_ConfigName);
	DDX_Text(pDX, IDC_UDM, m_UdmName);
	DDX_Text(pDX, IDC_GR, m_GrName);
	DDX_Text(pDX, IDC_GEN, m_GenName);
	DDX_Check(pDX, IDC_RUN_CG, m_RunCG);
	DDX_Check(pDX, IDC_RUN_GRE, m_RunGRE);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CFileInfoDialog, CDialog)
	//{{AFX_MSG_MAP(CFileInfoDialog)
	ON_BN_CLICKED(IDC_CONFIG_BTN, OnConfigBtn)
	ON_BN_CLICKED(IDC_GR_BTN, OnGrBtn)
	ON_BN_CLICKED(IDC_UDM_BTN, OnUdmBtn)
	ON_BN_CLICKED(IDC_GEN_BTN, OnGenBtn)
	ON_EN_CHANGE(IDC_CONFIG, OnChangeConfig)
	ON_EN_CHANGE(IDC_GEN, OnChangeGen)
	ON_EN_CHANGE(IDC_GR, OnChangeGr)
	ON_EN_CHANGE(IDC_UDM, OnChangeUdm)
	ON_BN_CLICKED(IDC_RENEW_PATH, OnRenewPath)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFileInfoDialog message handlers

void CFileInfoDialog::OnConfigBtn() 
{
	// TODO: Add your control notification handler code here
	CFileDialog getFile(false, ".mga", m_ConfigName, 
							OFN_HIDEREADONLY, 
							"UDM Files (*.xml;*.mga)|*.mga;*.xml|All Files (*.*)|*.*||" );
	getFile.m_ofn.lpstrTitle = "Config File location";
	if(getFile.DoModal() == IDOK)
	{	m_ConfigName = getFile.GetPathName();
		UpdateData(FALSE);
	}
}

void CFileInfoDialog::OnGrBtn() 
{
	// TODO: Add your control notification handler code here
	CString fn;
	if(m_GrName != "" && m_GrName.GetLength() > 2 && m_GrName.GetAt(1) == ':')
	{	fn = m_GrName;
	}
	else if(m_ConfigDir != "")
	{	fn = m_ConfigDir + m_GrName;
	}
	CFileDialog getFile(false, ".xml", fn, 
							OFN_HIDEREADONLY, 
							"XML Files (*.xml)|*.xml|All Files (*.*)|*.*||" );
	getFile.m_ofn.lpstrTitle = "GR File location";
	if(getFile.DoModal() == IDOK)
	{	if(m_ConfigDir != "")
			m_GrName = GetRelativeFilename((LPCSTR)m_ConfigDir,(LPCSTR)getFile.GetPathName());
		else
			m_GrName = getFile.GetPathName();

		UpdateData(FALSE);
	}
}

void CFileInfoDialog::OnUdmBtn() 
{
	// TODO: Add your control notification handler code here
	CString fn;
	if(m_UdmName != "" && m_UdmName.GetLength() > 2 && m_UdmName.GetAt(1) == ':')
	{	fn = m_UdmName;
	}
	else if(m_ConfigDir != "")
	{	fn = m_ConfigDir + m_UdmName;
	}
	CFileDialog getFile(false, m_UdmExt, m_UdmName, 
							OFN_HIDEREADONLY, 
							"UDM Meta (*.xml;*.udm)|*.xml;*.udm|All Files (*.*)|*.*||" );
	getFile.m_ofn.lpstrTitle = "UDM File location";
	if(getFile.DoModal() == IDOK)
	{	if(m_ConfigDir != "")
			m_UdmName = GetRelativeFilename((LPCSTR)m_ConfigDir,(LPCSTR)getFile.GetPathName());
		else
			m_UdmName = getFile.GetPathName();

		UpdateData(FALSE);
	}
	
}

void CFileInfoDialog::OnGenBtn() 
{
	// TODO: Add your control notification handler code here
	CString fn;
	if(m_GenName != "" && m_GenName.GetLength() > 2 && m_GenName.GetAt(1) == ':')
	{	fn = m_GenName;
	}
	else if(m_ConfigDir != "")
	{	fn = m_ConfigDir + m_GenName;
	}
	CFileDialog getFile(false, "", m_GenName, 
							OFN_HIDEREADONLY, 
							"All Files (*.*)|*.*||" );
	getFile.m_ofn.lpstrTitle = "Gen File(s) location";
	if(getFile.DoModal() == IDOK)
	{	if(m_ConfigDir != "")
			m_GenName = GetRelativeFilename((LPCSTR)m_ConfigDir,(LPCSTR)getFile.GetPathName());
		else
			m_GenName = getFile.GetPathName();

		UpdateData(FALSE);
	}
	
}

void CFileInfoDialog::OnOK() 
{
	// TODO: Add extra validation here
	UpdateData();

	if(m_ConfigDir == "")
	{	AfxMessageBox("File Info Error: The Config file name should have absolute path", MB_ICONSTOP);
		return;
	}

	if(m_GrName.GetLength() > 2 && m_GrName.GetAt(1) == ':')
		m_GrName = GetRelativeFilename((LPCSTR)m_ConfigDir,(LPCSTR)m_GrName);
	
	if(m_UdmName.GetLength() > 2 && m_UdmName.GetAt(1) == ':')
		m_UdmName = GetRelativeFilename((LPCSTR)m_ConfigDir,(LPCSTR)m_UdmName);

	if(m_GenName.GetLength() > 2 && m_GenName.GetAt(1) == ':')
		m_GenName = GetRelativeFilename((LPCSTR)m_ConfigDir,(LPCSTR)m_GenName);

	UpdateData(FALSE);
	
	CDialog::OnOK();
}

int CFileInfoDialog::DoModal() 
{
	// TODO: Add your specialized code here and/or call the base class
	if(m_ConfigName != "" && m_ConfigName.GetLength() > 2 && m_ConfigName.GetAt(1) == ':')
	{	int p = m_ConfigName.ReverseFind('\\');
		m_ConfigDir = m_ConfigName.Left(p+1);
	}
	return CDialog::DoModal();
}

void CFileInfoDialog::OnChangeConfig() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	UpdateData();

	int p = m_ConfigName.ReverseFind('\\');
	m_ConfigDir = m_ConfigName.Left(p+1);
		
}

void CFileInfoDialog::OnChangeGen() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	UpdateData();

}

void CFileInfoDialog::OnChangeGr() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	UpdateData();
}

void CFileInfoDialog::OnChangeUdm() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	UpdateData();
}

void CFileInfoDialog::OnRenewPath() 
{
	// TODO: Add your control notification handler code here
	int p = m_ConfigName.ReverseFind('\\');
	int c = m_ConfigName.GetLength() - (p+1);
	m_ConfigName = m_ConfigName.Right(c);
	m_ConfigDir  = m_MgaDir;
	m_ConfigName = m_ConfigDir + m_ConfigName;

	UpdateData(FALSE);
}
