#include "umt2cfg.h"
#include <UmlExt.h>
#include <UdmUtil.h>

void UMT2Config_0::operator()( const Packets_t& confRFs_1, const Packets_t& umtConfigmodels_3)
{
#ifdef PRINT_INFO
	std::cout << "UMT2Config_0" << std::endl;
#endif
	for( Packets_t::const_iterator itconfRF_6= confRFs_1.begin(), itumtConfigmodel_d= umtConfigmodels_3.begin(); itconfRF_6!= confRFs_1.end(), itumtConfigmodel_d!= umtConfigmodels_3.end(); ++itconfRF_6, ++itumtConfigmodel_d)
	{
		bool isUnique= isInputUnique( *itconfRF_6, *itumtConfigmodel_d);
		if( !isUnique)
			continue;
		Packets_t oneconfRF_a( 1, *itconfRF_6);
		Packets_t oneumtConfigmodel_11( 1, *itumtConfigmodel_d);
		executeOne( oneconfRF_a, oneumtConfigmodel_11);
	}
}

void UMT2Config_0::executeOne( const Packets_t& confRFs_1, const Packets_t& umtConfigmodels_3)
{
	if( ( !confRFs_1.empty())&& ( !umtConfigmodels_3.empty()))
		callInit_21d( confRFs_1, umtConfigmodels_3);
}

bool UMT2Config_0::isInputUnique( const Udm::Object& confRF_7, const Udm::Object& umtConfigmodel_e)
{
	bool isUnique= true;
	for( Packets_t::const_iterator itconfRF_9= _confRF_5.begin(), itumtConfigmodel_10= _umtConfigmodel_c.begin(); itconfRF_9!= _confRF_5.end(), itumtConfigmodel_10!= _umtConfigmodel_c.end(); ++itconfRF_9, ++itumtConfigmodel_10)
	{
		if( ( *itconfRF_9== confRF_7)&& ( *itumtConfigmodel_10== umtConfigmodel_e))
		{
			isUnique= false;
			break;
		}
	}
	if( isUnique)
	{
		_confRF_5.push_back( confRF_7);
		_umtConfigmodel_c.push_back( umtConfigmodel_e);
	}
	return isUnique;
}

void UMT2Config_0::callInit_21d( const Packets_t& rootFolders_14, const Packets_t& configurations_17)
{
	Packets_t rootFolders_16;
	Packets_t configurations_19;
	Init_13 init_13;
	init_13( rootFolders_14, configurations_17, rootFolders_16, configurations_19);
	if( ( !rootFolders_16.empty())&& ( !configurations_19.empty()))
		callMetaInfo_220( rootFolders_16, configurations_19);
}

void UMT2Config_0::callMetaInfo_220( const Packets_t& rootFolders_5d, const Packets_t& configurations_60)
{
	Packets_t rootFolders_5f;
	Packets_t configurations_62;
	MetaInfo_5c metaInfo_5c;
	metaInfo_5c( rootFolders_5d, configurations_60, rootFolders_5f, configurations_62);
	if( ( !rootFolders_5f.empty())&& ( !configurations_62.empty()))
		callUserCodeLibrary_223( rootFolders_5f, configurations_62);
	if( ( !rootFolders_5f.empty())&& ( !configurations_62.empty()))
		callUsageInfo_226( rootFolders_5f, configurations_62);
}

void UMT2Config_0::callUserCodeLibrary_223( const Packets_t& rootFolders_af, const Packets_t& configurations_b2)
{
	Packets_t rootFolders_b1;
	Packets_t configurations_b4;
	UserCodeLibrary_ae userCodeLibrary_ae;
	userCodeLibrary_ae( rootFolders_af, configurations_b2, rootFolders_b1, configurations_b4);
	if( ( !rootFolders_b1.empty())&& ( !configurations_b4.empty()))
		callUserCodeLibraryAttrs_229( rootFolders_b1, configurations_b4);
}

void UMT2Config_0::callUsageInfo_226( const Packets_t& confRFs_d9, const Packets_t& umtConfigmodels_db)
{
	Packets_t outs_dd;
	Packets_t outs_de;
	UsageInfo_d8 usageInfo_d8;
	usageInfo_d8( confRFs_d9, umtConfigmodels_db, outs_dd, outs_de);
	if( ( !outs_de.empty())&& ( !outs_dd.empty()))
		callRunTimeInfo_22c( outs_de, outs_dd);
}

void UMT2Config_0::callUserCodeLibraryAttrs_229( const Packets_t& rootFolders_38, const Packets_t& configurations_3a)
{
	UserCodeLibraryAttrs_37 userCodeLibraryAttrs_37;
	userCodeLibraryAttrs_37( rootFolders_38, configurations_3a);
}

void UMT2Config_0::callRunTimeInfo_22c( const Packets_t& rootFolders_86, const Packets_t& configurations_88)
{
	RunTimeInfo_85 runTimeInfo_85;
	runTimeInfo_85( rootFolders_86, configurations_88);
}

void Init_13::operator()( const Packets_t& rootFolders_14, const Packets_t& configurations_17, Packets_t& rootFolders_16, Packets_t& configurations_19)
{
#ifdef PRINT_INFO
	std::cout << "Init_13" << std::endl;
#endif
	_rootFolder_1a= &rootFolders_16;
	_configuration_1b= &configurations_19;
	processInputPackets( rootFolders_14, configurations_17);
	forwardInputs( );
}

bool Init_13::isInputUnique( const Udm::Object& rootFolder_20, const Udm::Object& configuration_29)
{
	bool isUnique= true;
	for( Packets_t::const_iterator itRootFolder_22= _rootFolder_1c.begin(), itConfiguration_2b= _configuration_25.begin(); itRootFolder_22!= _rootFolder_1c.end(), itConfiguration_2b!= _configuration_25.end(); ++itRootFolder_22, ++itConfiguration_2b)
	{
		if( ( *itRootFolder_22== rootFolder_20)&& ( *itConfiguration_2b== configuration_29))
		{
			isUnique= false;
			break;
		}
	}
	if( isUnique)
	{
		_rootFolder_1c.push_back( rootFolder_20);
		_configuration_25.push_back( configuration_29);
	}
	return isUnique;
}

void Init_13::processInputPackets( const Packets_t& rootFolders_14, const Packets_t& configurations_17)
{
	for( Packets_t::const_iterator itRootFolder_1d= rootFolders_14.begin(), itConfiguration_26= configurations_17.begin(); itRootFolder_1d!= rootFolders_14.end(), itConfiguration_26!= configurations_17.end(); ++itRootFolder_1d, ++itConfiguration_26)
	{
		bool isUnique= isInputUnique( *itRootFolder_1d, *itConfiguration_26);
		if( !isUnique)
			continue;
		bool isMatch= patternMatcher( *itRootFolder_1d, *itConfiguration_26);
		if( isMatch)
			effector( );
		_matches.clear();
	}
}

bool Init_13::patternMatcher( const Udm::Object& rootFolder_1e, const Udm::Object& configuration_27)
{
	for( int i= 0; i< 1; ++i)
	{
		if( false== Uml::IsDerivedFrom( rootFolder_1e.type(), GReATConfig::RootFolder::meta))
			continue;
		GReATConfig::RootFolder rootFolder_23= GReATConfig::RootFolder::Cast( rootFolder_1e);
		if( false== Uml::IsDerivedFrom( configuration_27.type(), UMLModelTransformer::Configuration::meta))
			continue;
		UMLModelTransformer::Configuration configuration_2c= UMLModelTransformer::Configuration::Cast( configuration_27);
		Match currMatch;
		currMatch.rootFolder_2e= rootFolder_23;
		currMatch.configuration_2f= configuration_2c;
		_matches.push_back( currMatch);
	}
	return !_matches.empty();
}

void Init_13::effector()
{
	for( std::list< Match>::const_iterator itMatch= _matches.begin(); itMatch!= _matches.end(); ++itMatch)
	{
		Match currMatch= *itMatch;
		GReATConfig::UsageInformation newUI_30= GReATConfig::UsageInformation::Create( currMatch.rootFolder_2e);
		GReATConfig::MetaInformation newCMIF_31= GReATConfig::MetaInformation::Create( currMatch.rootFolder_2e);
		GReATConfig::RuntimeInformation newRTI_32= GReATConfig::RuntimeInformation::Create( currMatch.rootFolder_2e);
		Udm::Object& CMIF= newCMIF_31;
		Udm::Object& Configuration= currMatch.configuration_2f;
		Udm::Object& RTI= newRTI_32;
		Udm::Object& RootFolder= currMatch.rootFolder_2e;
		Udm::Object& UI= newUI_30;
		{CMIF.SetStrVal("name", "1_MetaInfo"); UI.SetStrVal("name", "2_UserInfo"); RTI.SetStrVal("name", "3_RunTimeInfo"); };
		outputAppender( currMatch.rootFolder_2e, currMatch.configuration_2f);
	}
}

void Init_13::outputAppender( const GReATConfig::RootFolder& rootFolder_33, const UMLModelTransformer::Configuration& configuration_35)
{
	_rootFolder_1a->push_back( rootFolder_33);
	_configuration_1b->push_back( configuration_35);
}

void Init_13::forwardInputs()
{
	*_rootFolder_1a= _rootFolder_1c;
	*_configuration_1b= _configuration_25;
}

void UserCodeLibraryAttrs_37::operator()( const Packets_t& rootFolders_38, const Packets_t& configurations_3a)
{
#ifdef PRINT_INFO
	std::cout << "UserCodeLibraryAttrs_37" << std::endl;
#endif
	processInputPackets( rootFolders_38, configurations_3a);
}

bool UserCodeLibraryAttrs_37::isInputUnique( const Udm::Object& rootFolder_40, const Udm::Object& configuration_49)
{
	bool isUnique= true;
	for( Packets_t::const_iterator itRootFolder_42= _rootFolder_3c.begin(), itConfiguration_4b= _configuration_45.begin(); itRootFolder_42!= _rootFolder_3c.end(), itConfiguration_4b!= _configuration_45.end(); ++itRootFolder_42, ++itConfiguration_4b)
	{
		if( ( *itRootFolder_42== rootFolder_40)&& ( *itConfiguration_4b== configuration_49))
		{
			isUnique= false;
			break;
		}
	}
	if( isUnique)
	{
		_rootFolder_3c.push_back( rootFolder_40);
		_configuration_45.push_back( configuration_49);
	}
	return isUnique;
}

void UserCodeLibraryAttrs_37::processInputPackets( const Packets_t& rootFolders_38, const Packets_t& configurations_3a)
{
	for( Packets_t::const_iterator itRootFolder_3d= rootFolders_38.begin(), itConfiguration_46= configurations_3a.begin(); itRootFolder_3d!= rootFolders_38.end(), itConfiguration_46!= configurations_3a.end(); ++itRootFolder_3d, ++itConfiguration_46)
	{
		bool isUnique= isInputUnique( *itRootFolder_3d, *itConfiguration_46);
		if( !isUnique)
			continue;
		bool isMatch= patternMatcher( *itRootFolder_3d, *itConfiguration_46);
		if( isMatch)
			effector( );
		_matches.clear();
	}
}

bool UserCodeLibraryAttrs_37::patternMatcher( const Udm::Object& rootFolder_3e, const Udm::Object& configuration_47)
{
	for( int i= 0; i< 1; ++i)
	{
		if( false== Uml::IsDerivedFrom( rootFolder_3e.type(), GReATConfig::RootFolder::meta))
			continue;
		GReATConfig::RootFolder rootFolder_43= GReATConfig::RootFolder::Cast( rootFolder_3e);
		if( false== Uml::IsDerivedFrom( configuration_47.type(), UMLModelTransformer::Configuration::meta))
			continue;
		UMLModelTransformer::Configuration configuration_4c= UMLModelTransformer::Configuration::Cast( configuration_47);
		set< GReATConfig::MetaInformation> metaInformations_4e= rootFolder_43.MetaInformation_kind_children();
		for( set< GReATConfig::MetaInformation>::const_iterator itMetaInformation_4f= metaInformations_4e.begin(); itMetaInformation_4f!= metaInformations_4e.end(); ++itMetaInformation_4f)
		{
			GReATConfig::MetaInformation currMetaInformation_50= *itMetaInformation_4f;
			set< GReATConfig::UserCode> confUCLs_51= currMetaInformation_50.UserCode_kind_children();
			for( set< GReATConfig::UserCode>::const_iterator itconfUCL_52= confUCLs_51.begin(); itconfUCL_52!= confUCLs_51.end(); ++itconfUCL_52)
			{
				GReATConfig::UserCode currconfUCL_53= *itconfUCL_52;
				set< UMLModelTransformer::UserCodeLibrary> umtUCLs_54= configuration_4c.UserCodeLibrary_kind_children();
				for( set< UMLModelTransformer::UserCodeLibrary>::const_iterator itumtUCL_55= umtUCLs_54.begin(); itumtUCL_55!= umtUCLs_54.end(); ++itumtUCL_55)
				{
					UMLModelTransformer::UserCodeLibrary currumtUCL_56= *itumtUCL_55;
					Match currMatch;
					currMatch.rootFolder_57= rootFolder_43;
					currMatch.configuration_58= configuration_4c;
					currMatch.umtUCL_59= currumtUCL_56;
					currMatch.metaInformation_5a= currMetaInformation_50;
					currMatch.confUCL_5b= currconfUCL_53;
					_matches.push_back( currMatch);
				}
			}
		}
	}
	return !_matches.empty();
}

void UserCodeLibraryAttrs_37::effector()
{
	for( std::list< Match>::const_iterator itMatch= _matches.begin(); itMatch!= _matches.end(); ++itMatch)
	{
		Match currMatch= *itMatch;
		Udm::Object& Configuration= currMatch.configuration_58;
		Udm::Object& MetaInformation= currMatch.metaInformation_5a;
		Udm::Object& RootFolder= currMatch.rootFolder_57;
		Udm::Object& confUCL= currMatch.confUCL_5b;
		Udm::Object& umtUCL= currMatch.umtUCL_59;
		{cint_string t1(1024); cint_string t2(8192); umtUCL.GetStrVal("IncludeFiles",t1); confUCL.GetStrVal("IncFiles",t2); if (( t2.len()) && ( t1.len()) && (t2[ t2.len()-1] != ',')) t2+= ","; t2+= t1; confUCL.SetStrVal("IncFiles",t2); umtUCL.GetStrVal("LibraryFiles",t1); confUCL.GetStrVal("LibFiles",t2); if (( t2.len()) && ( t1.len()) && (t2[ t2.len()-1] != ',')) t2+= ","; t2+= t1; confUCL.SetStrVal("LibFiles",t2); umtUCL.GetStrVal("IncludePath",t1); confUCL.GetStrVal("IncDirs",t2); if (( t2.len()) && ( t1.len()) && (t2[ t2.len()-1] != ',')) t2+= ","; t2+= t1; confUCL.SetStrVal("IncDirs",t2); umtUCL.GetStrVal("LibraryPath",t1); confUCL.GetStrVal("LibDirs",t2); if (( t2.len()) && ( t1.len()) && (t2[ t2.len()-1] != ',')) t2+= ","; t2+= t1; confUCL.SetStrVal("LibDirs",t2);};
		outputAppender( );
	}
}

void UserCodeLibraryAttrs_37::outputAppender()
{
}

void MetaInfo_5c::operator()( const Packets_t& rootFolders_5d, const Packets_t& configurations_60, Packets_t& rootFolders_5f, Packets_t& configurations_62)
{
#ifdef PRINT_INFO
	std::cout << "MetaInfo_5c" << std::endl;
#endif
	_rootFolder_63= &rootFolders_5f;
	_configuration_64= &configurations_62;
	processInputPackets( rootFolders_5d, configurations_60);
	forwardInputs( );
}

bool MetaInfo_5c::isInputUnique( const Udm::Object& rootFolder_69, const Udm::Object& configuration_72)
{
	bool isUnique= true;
	for( Packets_t::const_iterator itRootFolder_6b= _rootFolder_65.begin(), itConfiguration_74= _configuration_6e.begin(); itRootFolder_6b!= _rootFolder_65.end(), itConfiguration_74!= _configuration_6e.end(); ++itRootFolder_6b, ++itConfiguration_74)
	{
		if( ( *itRootFolder_6b== rootFolder_69)&& ( *itConfiguration_74== configuration_72))
		{
			isUnique= false;
			break;
		}
	}
	if( isUnique)
	{
		_rootFolder_65.push_back( rootFolder_69);
		_configuration_6e.push_back( configuration_72);
	}
	return isUnique;
}

void MetaInfo_5c::processInputPackets( const Packets_t& rootFolders_5d, const Packets_t& configurations_60)
{
	for( Packets_t::const_iterator itRootFolder_66= rootFolders_5d.begin(), itConfiguration_6f= configurations_60.begin(); itRootFolder_66!= rootFolders_5d.end(), itConfiguration_6f!= configurations_60.end(); ++itRootFolder_66, ++itConfiguration_6f)
	{
		bool isUnique= isInputUnique( *itRootFolder_66, *itConfiguration_6f);
		if( !isUnique)
			continue;
		bool isMatch= patternMatcher( *itRootFolder_66, *itConfiguration_6f);
		if( isMatch)
			effector( );
		_matches.clear();
	}
}

bool MetaInfo_5c::patternMatcher( const Udm::Object& rootFolder_67, const Udm::Object& configuration_70)
{
	for( int i= 0; i< 1; ++i)
	{
		if( false== Uml::IsDerivedFrom( rootFolder_67.type(), GReATConfig::RootFolder::meta))
			continue;
		GReATConfig::RootFolder rootFolder_6c= GReATConfig::RootFolder::Cast( rootFolder_67);
		if( false== Uml::IsDerivedFrom( configuration_70.type(), UMLModelTransformer::Configuration::meta))
			continue;
		UMLModelTransformer::Configuration configuration_75= UMLModelTransformer::Configuration::Cast( configuration_70);
		set< GReATConfig::MetaInformation> cMIFs_77= rootFolder_6c.MetaInformation_kind_children();
		for( set< GReATConfig::MetaInformation>::const_iterator itCMIF_78= cMIFs_77.begin(); itCMIF_78!= cMIFs_77.end(); ++itCMIF_78)
		{
			GReATConfig::MetaInformation currCMIF_79= *itCMIF_78;
			set< UMLModelTransformer::MetaInformation> mIFs_7a= configuration_75.MetaInformation_kind_children();
			for( set< UMLModelTransformer::MetaInformation>::const_iterator itMIF_7b= mIFs_7a.begin(); itMIF_7b!= mIFs_7a.end(); ++itMIF_7b)
			{
				UMLModelTransformer::MetaInformation currMIF_7c= *itMIF_7b;
				Match currMatch;
				currMatch.rootFolder_7d= rootFolder_6c;
				currMatch.configuration_7e= configuration_75;
				currMatch.mIF_7f= currMIF_7c;
				currMatch.cMIF_80= currCMIF_79;
				_matches.push_back( currMatch);
			}
		}
	}
	return !_matches.empty();
}

void MetaInfo_5c::effector()
{
	for( std::list< Match>::const_iterator itMatch= _matches.begin(); itMatch!= _matches.end(); ++itMatch)
	{
		Match currMatch= *itMatch;
		Udm::Object& CMIF= currMatch.cMIF_80;
		Udm::Object& Configuration= currMatch.configuration_7e;
		Udm::Object& MIF= currMatch.mIF_7f;
		Udm::Object& RootFolder= currMatch.rootFolder_7d;
		{cint_string t1(1024); MIF.GetStrVal("TransformationFile",t1); CMIF.SetStrVal("TransformationFile",t1); MIF.GetStrVal("UdmProjectFile",t1); CMIF.SetStrVal("UdmProjectFile",t1); Configuration.GetStrVal("AMLinking",t1); CMIF.SetStrVal("MetaCodeGen",t1);};
		outputAppender( currMatch.rootFolder_7d, currMatch.configuration_7e);
	}
}

void MetaInfo_5c::outputAppender( const GReATConfig::RootFolder& rootFolder_81, const UMLModelTransformer::Configuration& configuration_83)
{
	_rootFolder_63->push_back( rootFolder_81);
	_configuration_64->push_back( configuration_83);
}

void MetaInfo_5c::forwardInputs()
{
	*_rootFolder_63= _rootFolder_65;
	*_configuration_64= _configuration_6e;
}

void RunTimeInfo_85::operator()( const Packets_t& rootFolders_86, const Packets_t& configurations_88)
{
#ifdef PRINT_INFO
	std::cout << "RunTimeInfo_85" << std::endl;
#endif
	processInputPackets( rootFolders_86, configurations_88);
}

bool RunTimeInfo_85::isInputUnique( const Udm::Object& rootFolder_8e, const Udm::Object& configuration_97)
{
	bool isUnique= true;
	for( Packets_t::const_iterator itRootFolder_90= _rootFolder_8a.begin(), itConfiguration_99= _configuration_93.begin(); itRootFolder_90!= _rootFolder_8a.end(), itConfiguration_99!= _configuration_93.end(); ++itRootFolder_90, ++itConfiguration_99)
	{
		if( ( *itRootFolder_90== rootFolder_8e)&& ( *itConfiguration_99== configuration_97))
		{
			isUnique= false;
			break;
		}
	}
	if( isUnique)
	{
		_rootFolder_8a.push_back( rootFolder_8e);
		_configuration_93.push_back( configuration_97);
	}
	return isUnique;
}

void RunTimeInfo_85::processInputPackets( const Packets_t& rootFolders_86, const Packets_t& configurations_88)
{
	for( Packets_t::const_iterator itRootFolder_8b= rootFolders_86.begin(), itConfiguration_94= configurations_88.begin(); itRootFolder_8b!= rootFolders_86.end(), itConfiguration_94!= configurations_88.end(); ++itRootFolder_8b, ++itConfiguration_94)
	{
		bool isUnique= isInputUnique( *itRootFolder_8b, *itConfiguration_94);
		if( !isUnique)
			continue;
		bool isMatch= patternMatcher( *itRootFolder_8b, *itConfiguration_94);
		if( isMatch)
			effector( );
		_matches.clear();
	}
}

bool RunTimeInfo_85::patternMatcher( const Udm::Object& rootFolder_8c, const Udm::Object& configuration_95)
{
	for( int i= 0; i< 1; ++i)
	{
		if( false== Uml::IsDerivedFrom( rootFolder_8c.type(), GReATConfig::RootFolder::meta))
			continue;
		GReATConfig::RootFolder rootFolder_91= GReATConfig::RootFolder::Cast( rootFolder_8c);
		if( false== Uml::IsDerivedFrom( configuration_95.type(), UMLModelTransformer::Configuration::meta))
			continue;
		UMLModelTransformer::Configuration configuration_9a= UMLModelTransformer::Configuration::Cast( configuration_95);
		set< UMLModelTransformer::FileType> fileTypes_9c= configuration_9a.FileType_kind_children();
		for( set< UMLModelTransformer::FileType>::const_iterator itFileType_9d= fileTypes_9c.begin(); itFileType_9d!= fileTypes_9c.end(); ++itFileType_9d)
		{
			UMLModelTransformer::FileType currFileType_9e= *itFileType_9d;
			set< GReATConfig::RuntimeInformation> runtimeInformations_9f= rootFolder_91.RuntimeInformation_kind_children();
			for( set< GReATConfig::RuntimeInformation>::const_iterator itRuntimeInformation_a0= runtimeInformations_9f.begin(); itRuntimeInformation_a0!= runtimeInformations_9f.end(); ++itRuntimeInformation_a0)
			{
				GReATConfig::RuntimeInformation currRuntimeInformation_a1= *itRuntimeInformation_a0;
				set< UMLModelTransformer::FileBind> fileBinds_a2= currFileType_9e.srcFileBind();
				for( set< UMLModelTransformer::FileBind>::const_iterator itFileBinds_a3= fileBinds_a2.begin(); itFileBinds_a3!= fileBinds_a2.end(); ++itFileBinds_a3)
				{
					UMLModelTransformer::FileBind currFileBindPseudo_a4_a5= *itFileBinds_a3;
					UMLModelTransformer::File file_a6= currFileBindPseudo_a4_a5.srcFileBind_end();
					Match currMatch;
					currMatch.rootFolder_a7= rootFolder_91;
					currMatch.configuration_a8= configuration_9a;
					currMatch.fileType_a9= currFileType_9e;
					currMatch.runtimeInformation_aa= currRuntimeInformation_a1;
					currMatch.file_ab= file_a6;
					currMatch.fileBindPseudo_a4_ac= currFileBindPseudo_a4_a5;
					_matches.push_back( currMatch);
				}
			}
		}
	}
	return !_matches.empty();
}

void RunTimeInfo_85::effector()
{
	for( std::list< Match>::const_iterator itMatch= _matches.begin(); itMatch!= _matches.end(); ++itMatch)
	{
		Match currMatch= *itMatch;
		GReATConfig::InputFile newInputFile_ad= GReATConfig::InputFile::Create( currMatch.runtimeInformation_aa);
		Udm::Object& Configuration= currMatch.configuration_a8;
		Udm::Object& File= currMatch.file_ab;
		Udm::Object& FileBindPseudo_a4= currMatch.fileBindPseudo_a4_ac;
		Udm::Object& FileType= currMatch.fileType_a9;
		Udm::Object& InputFile= newInputFile_ad;
		Udm::Object& RootFolder= currMatch.rootFolder_a7;
		Udm::Object& RuntimeInformation= currMatch.runtimeInformation_aa;
		{cint_string t1(1024); File.GetStrVal("FilePathName",t1); InputFile.SetStrVal("FileName",t1); File.GetStrVal("CopyPathName",t1); InputFile.SetStrVal("CopyName",t1); FileType.GetStrVal("name",t1); InputFile.SetStrVal("FileID",t1); InputFile.SetStrVal("name",t1);};
		outputAppender( );
	}
}

void RunTimeInfo_85::outputAppender()
{
}

void UserCodeLibrary_ae::operator()( const Packets_t& rootFolders_af, const Packets_t& configurations_b2, Packets_t& rootFolders_b1, Packets_t& configurations_b4)
{
#ifdef PRINT_INFO
	std::cout << "UserCodeLibrary_ae" << std::endl;
#endif
	_rootFolder_b5= &rootFolders_b1;
	_configuration_b6= &configurations_b4;
	processInputPackets( rootFolders_af, configurations_b2);
	forwardInputs( );
}

bool UserCodeLibrary_ae::isInputUnique( const Udm::Object& rootFolder_bb, const Udm::Object& configuration_c4)
{
	bool isUnique= true;
	for( Packets_t::const_iterator itRootFolder_bd= _rootFolder_b7.begin(), itConfiguration_c6= _configuration_c0.begin(); itRootFolder_bd!= _rootFolder_b7.end(), itConfiguration_c6!= _configuration_c0.end(); ++itRootFolder_bd, ++itConfiguration_c6)
	{
		if( ( *itRootFolder_bd== rootFolder_bb)&& ( *itConfiguration_c6== configuration_c4))
		{
			isUnique= false;
			break;
		}
	}
	if( isUnique)
	{
		_rootFolder_b7.push_back( rootFolder_bb);
		_configuration_c0.push_back( configuration_c4);
	}
	return isUnique;
}

void UserCodeLibrary_ae::processInputPackets( const Packets_t& rootFolders_af, const Packets_t& configurations_b2)
{
	for( Packets_t::const_iterator itRootFolder_b8= rootFolders_af.begin(), itConfiguration_c1= configurations_b2.begin(); itRootFolder_b8!= rootFolders_af.end(), itConfiguration_c1!= configurations_b2.end(); ++itRootFolder_b8, ++itConfiguration_c1)
	{
		bool isUnique= isInputUnique( *itRootFolder_b8, *itConfiguration_c1);
		if( !isUnique)
			continue;
		bool isMatch= patternMatcher( *itRootFolder_b8, *itConfiguration_c1);
		if( isMatch)
			effector( );
		_matches.clear();
	}
}

bool UserCodeLibrary_ae::patternMatcher( const Udm::Object& rootFolder_b9, const Udm::Object& configuration_c2)
{
	for( int i= 0; i< 1; ++i)
	{
		if( false== Uml::IsDerivedFrom( rootFolder_b9.type(), GReATConfig::RootFolder::meta))
			continue;
		GReATConfig::RootFolder rootFolder_be= GReATConfig::RootFolder::Cast( rootFolder_b9);
		if( false== Uml::IsDerivedFrom( configuration_c2.type(), UMLModelTransformer::Configuration::meta))
			continue;
		UMLModelTransformer::Configuration configuration_c7= UMLModelTransformer::Configuration::Cast( configuration_c2);
		set< GReATConfig::MetaInformation> metaInformations_c9= rootFolder_be.MetaInformation_kind_children();
		for( set< GReATConfig::MetaInformation>::const_iterator itMetaInformation_ca= metaInformations_c9.begin(); itMetaInformation_ca!= metaInformations_c9.end(); ++itMetaInformation_ca)
		{
			GReATConfig::MetaInformation currMetaInformation_cb= *itMetaInformation_ca;
			set< UMLModelTransformer::UserCodeLibrary> userCodeLibrarys_cc= configuration_c7.UserCodeLibrary_kind_children();
			for( set< UMLModelTransformer::UserCodeLibrary>::const_iterator itUserCodeLibrary_cd= userCodeLibrarys_cc.begin(); itUserCodeLibrary_cd!= userCodeLibrarys_cc.end(); ++itUserCodeLibrary_cd)
			{
				UMLModelTransformer::UserCodeLibrary currUserCodeLibrary_ce= *itUserCodeLibrary_cd;
				Match currMatch;
				currMatch.rootFolder_cf= rootFolder_be;
				currMatch.configuration_d0= configuration_c7;
				currMatch.userCodeLibrary_d1= currUserCodeLibrary_ce;
				currMatch.metaInformation_d2= currMetaInformation_cb;
				_matches.push_back( currMatch);
				return true;
			}
		}
	}
	return !_matches.empty();
}

void UserCodeLibrary_ae::effector()
{
	for( std::list< Match>::const_iterator itMatch= _matches.begin(); itMatch!= _matches.end(); ++itMatch)
	{
		Match currMatch= *itMatch;
		GReATConfig::UserCode newUserCode_d3= GReATConfig::UserCode::Create( currMatch.metaInformation_d2);
		outputAppender( currMatch.rootFolder_cf, currMatch.configuration_d0);
	}
}

void UserCodeLibrary_ae::outputAppender( const GReATConfig::RootFolder& rootFolder_d4, const UMLModelTransformer::Configuration& configuration_d6)
{
	_rootFolder_b5->push_back( rootFolder_d4);
	_configuration_b6->push_back( configuration_d6);
}

void UserCodeLibrary_ae::forwardInputs()
{
	*_rootFolder_b5= _rootFolder_b7;
	*_configuration_b6= _configuration_c0;
}

void UsageInfo_d8::operator()( const Packets_t& confRFs_d9, const Packets_t& umtConfigmodels_db, Packets_t& outs_dd, Packets_t& outs_de)
{
#ifdef PRINT_INFO
	std::cout << "UsageInfo_d8" << std::endl;
#endif
	_out_df= &outs_dd;
	_out_e0= &outs_de;
	if( ( !confRFs_d9.empty())&& ( !umtConfigmodels_db.empty()))
		callUsageInfo_211( confRFs_d9, umtConfigmodels_db);
	_out_e0->insert( _out_e0->end(), confRFs_d9.begin(), confRFs_d9.end());
	_out_df->insert( _out_df->end(), umtConfigmodels_db.begin(), umtConfigmodels_db.end());
}

void UsageInfo_d8::callUsageInfo_211( const Packets_t& rootFolders_e2, const Packets_t& configurations_e4)
{
	Packets_t configurations_e6;
	Packets_t uIs_e7;
	Packets_t expressions_e8;
	UsageInfo_e1 usageInfo_e1;
	usageInfo_e1( rootFolders_e2, configurations_e4, configurations_e6, uIs_e7, expressions_e8);
	if( ( !expressions_e8.empty())&& ( !uIs_e7.empty()))
		callGetPath_214( expressions_e8, uIs_e7);
	if( ( !uIs_e7.empty())&& ( !configurations_e6.empty()))
		callUsagefile_217( uIs_e7, configurations_e6);
}

void UsageInfo_d8::callGetPath_214( const Packets_t& ins_111, const Packets_t& ins_113)
{
	GetPath_110 getPath_110;
	getPath_110( ins_111, ins_113);
}

void UsageInfo_d8::callUsagefile_217( const Packets_t& usageInformations_1c0, const Packets_t& configurations_1c3)
{
	Packets_t usageInformations_1c2;
	Packets_t fileTypes_1c5;
	Usagefile_1bf usagefile_1bf;
	usagefile_1bf( usageInformations_1c0, configurations_1c3, usageInformations_1c2, fileTypes_1c5);
	if( ( !usageInformations_1c2.empty())&& ( !fileTypes_1c5.empty()))
		callTransformationInput_21a( usageInformations_1c2, fileTypes_1c5);
}

void UsageInfo_d8::callTransformationInput_21a( const Packets_t& usageInformations_1e6, const Packets_t& fileTypes_1e8)
{
	TransformationInput_1e5 transformationInput_1e5;
	transformationInput_1e5( usageInformations_1e6, fileTypes_1e8);
}

void UsageInfo_e1::operator()( const Packets_t& rootFolders_e2, const Packets_t& configurations_e4, Packets_t& configurations_e6, Packets_t& uIs_e7, Packets_t& expressions_e8)
{
#ifdef PRINT_INFO
	std::cout << "UsageInfo_e1" << std::endl;
#endif
	_configuration_e9= &configurations_e6;
	_uI_ea= &uIs_e7;
	_expression_eb= &expressions_e8;
	processInputPackets( rootFolders_e2, configurations_e4);
}

bool UsageInfo_e1::isInputUnique( const Udm::Object& rootFolder_f0, const Udm::Object& configuration_f9)
{
	bool isUnique= true;
	for( Packets_t::const_iterator itRootFolder_f2= _rootFolder_ec.begin(), itConfiguration_fb= _configuration_f5.begin(); itRootFolder_f2!= _rootFolder_ec.end(), itConfiguration_fb!= _configuration_f5.end(); ++itRootFolder_f2, ++itConfiguration_fb)
	{
		if( ( *itRootFolder_f2== rootFolder_f0)&& ( *itConfiguration_fb== configuration_f9))
		{
			isUnique= false;
			break;
		}
	}
	if( isUnique)
	{
		_rootFolder_ec.push_back( rootFolder_f0);
		_configuration_f5.push_back( configuration_f9);
	}
	return isUnique;
}

void UsageInfo_e1::processInputPackets( const Packets_t& rootFolders_e2, const Packets_t& configurations_e4)
{
	for( Packets_t::const_iterator itRootFolder_ed= rootFolders_e2.begin(), itConfiguration_f6= configurations_e4.begin(); itRootFolder_ed!= rootFolders_e2.end(), itConfiguration_f6!= configurations_e4.end(); ++itRootFolder_ed, ++itConfiguration_f6)
	{
		bool isUnique= isInputUnique( *itRootFolder_ed, *itConfiguration_f6);
		if( !isUnique)
			continue;
		bool isMatch= patternMatcher( *itRootFolder_ed, *itConfiguration_f6);
		if( isMatch)
			effector( );
		_matches.clear();
	}
}

bool UsageInfo_e1::patternMatcher( const Udm::Object& rootFolder_ee, const Udm::Object& configuration_f7)
{
	for( int i= 0; i< 1; ++i)
	{
		if( false== Uml::IsDerivedFrom( rootFolder_ee.type(), GReATConfig::RootFolder::meta))
			continue;
		GReATConfig::RootFolder rootFolder_f3= GReATConfig::RootFolder::Cast( rootFolder_ee);
		if( false== Uml::IsDerivedFrom( configuration_f7.type(), UMLModelTransformer::Configuration::meta))
			continue;
		UMLModelTransformer::Configuration configuration_fc= UMLModelTransformer::Configuration::Cast( configuration_f7);
		set< GReATConfig::UsageInformation> uIs_fe= rootFolder_f3.UsageInformation_kind_children();
		for( set< GReATConfig::UsageInformation>::const_iterator itUI_ff= uIs_fe.begin(); itUI_ff!= uIs_fe.end(); ++itUI_ff)
		{
			GReATConfig::UsageInformation currUI_100= *itUI_ff;
			set< UMLModelTransformer::StartRule> startRules_101= configuration_fc.StartRule_kind_children();
			for( set< UMLModelTransformer::StartRule>::const_iterator itStartRule_102= startRules_101.begin(); itStartRule_102!= startRules_101.end(); ++itStartRule_102)
			{
				UMLModelTransformer::StartRule currStartRule_103= *itStartRule_102;
				UMLModelTransformer::Expression expression_104= currStartRule_103.ref();
				if( !expression_104)
					continue;
				Match currMatch;
				currMatch.rootFolder_105= rootFolder_f3;
				currMatch.configuration_106= configuration_fc;
				currMatch.uI_107= currUI_100;
				currMatch.startRule_108= currStartRule_103;
				currMatch.expression_109= expression_104;
				_matches.push_back( currMatch);
			}
		}
	}
	return !_matches.empty();
}

void UsageInfo_e1::effector()
{
	for( std::list< Match>::const_iterator itMatch= _matches.begin(); itMatch!= _matches.end(); ++itMatch)
	{
		Match currMatch= *itMatch;
		Udm::Object& Configuration= currMatch.configuration_106;
		Udm::Object& Expression= currMatch.expression_109;
		Udm::Object& RootFolder= currMatch.rootFolder_105;
		Udm::Object& StartRule= currMatch.startRule_108;
		Udm::Object& UI= currMatch.uI_107;
		{cint_string t1(255); Expression.GetStrVal("name", t1); UI.SetStrVal("StartRulePath",t1); };
		outputAppender( currMatch.configuration_106, currMatch.uI_107, currMatch.expression_109);
	}
}

void UsageInfo_e1::outputAppender( const UMLModelTransformer::Configuration& configuration_10a, const GReATConfig::UsageInformation& uI_10c, const UMLModelTransformer::Expression& expression_10e)
{
	_configuration_e9->push_back( configuration_10a);
	_uI_ea->push_back( uI_10c);
	_expression_eb->push_back( expression_10e);
}

void GetPath_110::operator()( const Packets_t& ins_111, const Packets_t& ins_113)
{
#ifdef PRINT_INFO
	std::cout << "GetPath_110" << std::endl;
#endif
	if( ( !ins_111.empty())&& ( !ins_113.empty()))
		callTest_1b9( ins_111, ins_113);
}

void GetPath_110::callTest_1b9( const Packets_t& ins_116, const Packets_t& ins_118)
{
	Packets_t outs_11a;
	Packets_t outs_11b;
	Test_115 test_115;
	test_115( ins_116, ins_118, outs_11a, outs_11b);
	if( ( !outs_11b.empty())&& ( !outs_11a.empty()))
		callStartRulePath_1bc( outs_11b, outs_11a);
}

void GetPath_110::callStartRulePath_1bc( const Packets_t& parents_199, const Packets_t& uIs_19c)
{
	Packets_t parents_19b;
	Packets_t uIs_19e;
	StartRulePath_198 startRulePath_198;
	startRulePath_198( parents_199, uIs_19c, parents_19b, uIs_19e);
	if( ( !parents_19b.empty())&& ( !uIs_19e.empty()))
		callTest_1b9( parents_19b, uIs_19e);
}

void Test_115::operator()( const Packets_t& ins_116, const Packets_t& ins_118, Packets_t& outs_11a, Packets_t& outs_11b)
{
#ifdef PRINT_INFO
	std::cout << "Test_115" << std::endl;
#endif
	_out_11c= &outs_11a;
	_out_11d= &outs_11b;
	for( Packets_t::const_iterator itIn_11f= ins_116.begin(), itIn_126= ins_118.begin(); itIn_11f!= ins_116.end(), itIn_126!= ins_118.end(); ++itIn_11f, ++itIn_126)
	{
		bool isUnique= isInputUnique( *itIn_11f, *itIn_126);
		if( !isUnique)
			continue;
		Packets_t oneIn_123( 1, *itIn_11f);
		Packets_t oneIn_12a( 1, *itIn_126);
		executeOne( oneIn_123, oneIn_12a);
	}
}

void Test_115::executeOne( const Packets_t& ins_116, const Packets_t& ins_118)
{
	Packets_t uIs_131;
	Packets_t parents_132;
	RuleCompound_12c ruleCompound_12c;
	bool isMatchRuleCompound_12c= ruleCompound_12c( ins_116, ins_118, uIs_131, parents_132);
	_out_11c->insert( _out_11c->end(), uIs_131.begin(), uIs_131.end());
	_out_11d->insert( _out_11d->end(), parents_132.begin(), parents_132.end());
	if( isMatchRuleCompound_12c)
		return;
	Packets_t uIs_155;
	Packets_t parents_156;
	TestCompound_150 testCompound_150;
	bool isMatchTestCompound_150= testCompound_150( ins_116, ins_118, uIs_155, parents_156);
	_out_11c->insert( _out_11c->end(), uIs_155.begin(), uIs_155.end());
	_out_11d->insert( _out_11d->end(), parents_156.begin(), parents_156.end());
	if( isMatchTestCompound_150)
		return;
	Packets_t uIs_179;
	Packets_t parents_17a;
	CompoundCompound_174 compoundCompound_174;
	bool isMatchCompoundCompound_174= compoundCompound_174( ins_116, ins_118, uIs_179, parents_17a);
	_out_11c->insert( _out_11c->end(), uIs_179.begin(), uIs_179.end());
	_out_11d->insert( _out_11d->end(), parents_17a.begin(), parents_17a.end());
	if( isMatchCompoundCompound_174)
		return;
}

bool Test_115::isInputUnique( const Udm::Object& in_120, const Udm::Object& in_127)
{
	bool isUnique= true;
	for( Packets_t::const_iterator itIn_122= _in_11e.begin(), itIn_129= _in_125.begin(); itIn_122!= _in_11e.end(), itIn_129!= _in_125.end(); ++itIn_122, ++itIn_129)
	{
		if( ( *itIn_122== in_120)&& ( *itIn_129== in_127))
		{
			isUnique= false;
			break;
		}
	}
	if( isUnique)
	{
		_in_11e.push_back( in_120);
		_in_125.push_back( in_127);
	}
	return isUnique;
}

bool RuleCompound_12c::operator()( const Packets_t& childs_12d, const Packets_t& uIs_12f, Packets_t& uIs_131, Packets_t& parents_132)
{
#ifdef PRINT_INFO
	std::cout << "RuleCompound_12c" << std::endl;
#endif
	_uI_133= &uIs_131;
	_parent_134= &parents_132;
	processInputPackets( childs_12d, uIs_12f);
	if( false== _matches.empty())
		return true;
	return false;
}

bool RuleCompound_12c::isInputUnique( const Udm::Object& child_139, const Udm::Object& uI_142)
{
	bool isUnique= true;
	for( Packets_t::const_iterator itChild_13b= _child_135.begin(), itUI_144= _uI_13e.begin(); itChild_13b!= _child_135.end(), itUI_144!= _uI_13e.end(); ++itChild_13b, ++itUI_144)
	{
		if( ( *itChild_13b== child_139)&& ( *itUI_144== uI_142))
		{
			isUnique= false;
			break;
		}
	}
	if( isUnique)
	{
		_child_135.push_back( child_139);
		_uI_13e.push_back( uI_142);
	}
	return isUnique;
}

void RuleCompound_12c::processInputPackets( const Packets_t& childs_12d, const Packets_t& uIs_12f)
{
	for( Packets_t::const_iterator itChild_136= childs_12d.begin(), itUI_13f= uIs_12f.begin(); itChild_136!= childs_12d.end(), itUI_13f!= uIs_12f.end(); ++itChild_136, ++itUI_13f)
	{
		bool isUnique= isInputUnique( *itChild_136, *itUI_13f);
		if( !isUnique)
			continue;
		bool isMatch= patternMatcher( *itChild_136, *itUI_13f);
	}
	for( std::list< Match>::const_iterator itMatch= _matches.begin(); itMatch!= _matches.end(); ++itMatch)
	{
		Match currMatch= *itMatch;
		outputAppender( currMatch.uI_14a, currMatch.parent_14b);
	}
}

bool RuleCompound_12c::patternMatcher( const Udm::Object& child_137, const Udm::Object& uI_140)
{
	for( int i= 0; i< 1; ++i)
	{
		if( false== Uml::IsDerivedFrom( child_137.type(), UMLModelTransformer::Rule::meta))
			continue;
		UMLModelTransformer::Rule child_13c= UMLModelTransformer::Rule::Cast( child_137);
		if( false== Uml::IsDerivedFrom( uI_140.type(), GReATConfig::UsageInformation::meta))
			continue;
		GReATConfig::UsageInformation uI_145= GReATConfig::UsageInformation::Cast( uI_140);
		Udm::Object childParent_147= child_13c.container();
		if( false== Uml::IsDerivedFrom( childParent_147.type(), UMLModelTransformer::CompoundRule::meta))
			continue;
		UMLModelTransformer::CompoundRule parentChild_148= UMLModelTransformer::CompoundRule::Cast( childParent_147);
		Match currMatch;
		currMatch.child_149= child_13c;
		currMatch.uI_14a= uI_145;
		currMatch.parent_14b= parentChild_148;
		_matches.push_back( currMatch);
	}
	return !_matches.empty();
}

void RuleCompound_12c::outputAppender( const GReATConfig::UsageInformation& uI_14c, const UMLModelTransformer::CompoundRule& parent_14e)
{
	_uI_133->push_back( uI_14c);
	_parent_134->push_back( parent_14e);
}

bool TestCompound_150::operator()( const Packets_t& childs_151, const Packets_t& uIs_153, Packets_t& uIs_155, Packets_t& parents_156)
{
#ifdef PRINT_INFO
	std::cout << "TestCompound_150" << std::endl;
#endif
	_uI_157= &uIs_155;
	_parent_158= &parents_156;
	processInputPackets( childs_151, uIs_153);
	if( false== _matches.empty())
		return true;
	return false;
}

bool TestCompound_150::isInputUnique( const Udm::Object& child_15d, const Udm::Object& uI_166)
{
	bool isUnique= true;
	for( Packets_t::const_iterator itChild_15f= _child_159.begin(), itUI_168= _uI_162.begin(); itChild_15f!= _child_159.end(), itUI_168!= _uI_162.end(); ++itChild_15f, ++itUI_168)
	{
		if( ( *itChild_15f== child_15d)&& ( *itUI_168== uI_166))
		{
			isUnique= false;
			break;
		}
	}
	if( isUnique)
	{
		_child_159.push_back( child_15d);
		_uI_162.push_back( uI_166);
	}
	return isUnique;
}

void TestCompound_150::processInputPackets( const Packets_t& childs_151, const Packets_t& uIs_153)
{
	for( Packets_t::const_iterator itChild_15a= childs_151.begin(), itUI_163= uIs_153.begin(); itChild_15a!= childs_151.end(), itUI_163!= uIs_153.end(); ++itChild_15a, ++itUI_163)
	{
		bool isUnique= isInputUnique( *itChild_15a, *itUI_163);
		if( !isUnique)
			continue;
		bool isMatch= patternMatcher( *itChild_15a, *itUI_163);
	}
	for( std::list< Match>::const_iterator itMatch= _matches.begin(); itMatch!= _matches.end(); ++itMatch)
	{
		Match currMatch= *itMatch;
		outputAppender( currMatch.uI_16e, currMatch.parent_16f);
	}
}

bool TestCompound_150::patternMatcher( const Udm::Object& child_15b, const Udm::Object& uI_164)
{
	for( int i= 0; i< 1; ++i)
	{
		if( false== Uml::IsDerivedFrom( child_15b.type(), UMLModelTransformer::Test::meta))
			continue;
		UMLModelTransformer::Test child_160= UMLModelTransformer::Test::Cast( child_15b);
		if( false== Uml::IsDerivedFrom( uI_164.type(), GReATConfig::UsageInformation::meta))
			continue;
		GReATConfig::UsageInformation uI_169= GReATConfig::UsageInformation::Cast( uI_164);
		Udm::Object childParent_16b= child_160.container();
		if( false== Uml::IsDerivedFrom( childParent_16b.type(), UMLModelTransformer::CompoundRule::meta))
			continue;
		UMLModelTransformer::CompoundRule parentChild_16c= UMLModelTransformer::CompoundRule::Cast( childParent_16b);
		Match currMatch;
		currMatch.child_16d= child_160;
		currMatch.uI_16e= uI_169;
		currMatch.parent_16f= parentChild_16c;
		_matches.push_back( currMatch);
	}
	return !_matches.empty();
}

void TestCompound_150::outputAppender( const GReATConfig::UsageInformation& uI_170, const UMLModelTransformer::CompoundRule& parent_172)
{
	_uI_157->push_back( uI_170);
	_parent_158->push_back( parent_172);
}

bool CompoundCompound_174::operator()( const Packets_t& childs_175, const Packets_t& uIs_177, Packets_t& uIs_179, Packets_t& parents_17a)
{
#ifdef PRINT_INFO
	std::cout << "CompoundCompound_174" << std::endl;
#endif
	_uI_17b= &uIs_179;
	_parent_17c= &parents_17a;
	processInputPackets( childs_175, uIs_177);
	if( false== _matches.empty())
		return true;
	return false;
}

bool CompoundCompound_174::isInputUnique( const Udm::Object& child_181, const Udm::Object& uI_18a)
{
	bool isUnique= true;
	for( Packets_t::const_iterator itChild_183= _child_17d.begin(), itUI_18c= _uI_186.begin(); itChild_183!= _child_17d.end(), itUI_18c!= _uI_186.end(); ++itChild_183, ++itUI_18c)
	{
		if( ( *itChild_183== child_181)&& ( *itUI_18c== uI_18a))
		{
			isUnique= false;
			break;
		}
	}
	if( isUnique)
	{
		_child_17d.push_back( child_181);
		_uI_186.push_back( uI_18a);
	}
	return isUnique;
}

void CompoundCompound_174::processInputPackets( const Packets_t& childs_175, const Packets_t& uIs_177)
{
	for( Packets_t::const_iterator itChild_17e= childs_175.begin(), itUI_187= uIs_177.begin(); itChild_17e!= childs_175.end(), itUI_187!= uIs_177.end(); ++itChild_17e, ++itUI_187)
	{
		bool isUnique= isInputUnique( *itChild_17e, *itUI_187);
		if( !isUnique)
			continue;
		bool isMatch= patternMatcher( *itChild_17e, *itUI_187);
	}
	for( std::list< Match>::const_iterator itMatch= _matches.begin(); itMatch!= _matches.end(); ++itMatch)
	{
		Match currMatch= *itMatch;
		outputAppender( currMatch.uI_192, currMatch.parent_193);
	}
}

bool CompoundCompound_174::patternMatcher( const Udm::Object& child_17f, const Udm::Object& uI_188)
{
	for( int i= 0; i< 1; ++i)
	{
		if( false== Uml::IsDerivedFrom( child_17f.type(), UMLModelTransformer::CompoundRule::meta))
			continue;
		UMLModelTransformer::CompoundRule child_184= UMLModelTransformer::CompoundRule::Cast( child_17f);
		if( false== Uml::IsDerivedFrom( uI_188.type(), GReATConfig::UsageInformation::meta))
			continue;
		GReATConfig::UsageInformation uI_18d= GReATConfig::UsageInformation::Cast( uI_188);
		Udm::Object childParent_18f= child_184.container();
		if( false== Uml::IsDerivedFrom( childParent_18f.type(), UMLModelTransformer::CompoundRule::meta))
			continue;
		UMLModelTransformer::CompoundRule parentChild_190= UMLModelTransformer::CompoundRule::Cast( childParent_18f);
		Match currMatch;
		currMatch.child_191= child_184;
		currMatch.uI_192= uI_18d;
		currMatch.parent_193= parentChild_190;
		_matches.push_back( currMatch);
	}
	return !_matches.empty();
}

void CompoundCompound_174::outputAppender( const GReATConfig::UsageInformation& uI_194, const UMLModelTransformer::CompoundRule& parent_196)
{
	_uI_17b->push_back( uI_194);
	_parent_17c->push_back( parent_196);
}

void StartRulePath_198::operator()( const Packets_t& parents_199, const Packets_t& uIs_19c, Packets_t& parents_19b, Packets_t& uIs_19e)
{
#ifdef PRINT_INFO
	std::cout << "StartRulePath_198" << std::endl;
#endif
	_parent_19f= &parents_19b;
	_uI_1a0= &uIs_19e;
	processInputPackets( parents_199, uIs_19c);
	forwardInputs( );
}

bool StartRulePath_198::isInputUnique( const Udm::Object& parent_1a5, const Udm::Object& uI_1ae)
{
	bool isUnique= true;
	for( Packets_t::const_iterator itParent_1a7= _parent_1a1.begin(), itUI_1b0= _uI_1aa.begin(); itParent_1a7!= _parent_1a1.end(), itUI_1b0!= _uI_1aa.end(); ++itParent_1a7, ++itUI_1b0)
	{
		if( ( *itParent_1a7== parent_1a5)&& ( *itUI_1b0== uI_1ae))
		{
			isUnique= false;
			break;
		}
	}
	if( isUnique)
	{
		_parent_1a1.push_back( parent_1a5);
		_uI_1aa.push_back( uI_1ae);
	}
	return isUnique;
}

void StartRulePath_198::processInputPackets( const Packets_t& parents_199, const Packets_t& uIs_19c)
{
	for( Packets_t::const_iterator itParent_1a2= parents_199.begin(), itUI_1ab= uIs_19c.begin(); itParent_1a2!= parents_199.end(), itUI_1ab!= uIs_19c.end(); ++itParent_1a2, ++itUI_1ab)
	{
		bool isUnique= isInputUnique( *itParent_1a2, *itUI_1ab);
		if( !isUnique)
			continue;
		bool isMatch= patternMatcher( *itParent_1a2, *itUI_1ab);
		if( isMatch)
			effector( );
		_matches.clear();
	}
}

bool StartRulePath_198::patternMatcher( const Udm::Object& parent_1a3, const Udm::Object& uI_1ac)
{
	for( int i= 0; i< 1; ++i)
	{
		if( false== Uml::IsDerivedFrom( parent_1a3.type(), UMLModelTransformer::Expression::meta))
			continue;
		UMLModelTransformer::Expression parent_1a8= UMLModelTransformer::Expression::Cast( parent_1a3);
		if( false== Uml::IsDerivedFrom( uI_1ac.type(), GReATConfig::UsageInformation::meta))
			continue;
		GReATConfig::UsageInformation uI_1b1= GReATConfig::UsageInformation::Cast( uI_1ac);
		Match currMatch;
		currMatch.parent_1b3= parent_1a8;
		currMatch.uI_1b4= uI_1b1;
		_matches.push_back( currMatch);
	}
	return !_matches.empty();
}

void StartRulePath_198::effector()
{
	for( std::list< Match>::const_iterator itMatch= _matches.begin(); itMatch!= _matches.end(); ++itMatch)
	{
		Match currMatch= *itMatch;
		Udm::Object& Parent= currMatch.parent_1b3;
		Udm::Object& UI= currMatch.uI_1b4;
		{cint_string t1(1024), t2(1024); Parent.GetStrVal("name",t1); UI.GetStrVal("StartRulePath",t2); t1 += ";"; t1 += t2; UI.SetStrVal("StartRulePath",t1);};
		outputAppender( currMatch.parent_1b3, currMatch.uI_1b4);
	}
}

void StartRulePath_198::outputAppender( const UMLModelTransformer::Expression& parent_1b5, const GReATConfig::UsageInformation& uI_1b7)
{
	_parent_19f->push_back( parent_1b5);
	_uI_1a0->push_back( uI_1b7);
}

void StartRulePath_198::forwardInputs()
{
	*_parent_19f= _parent_1a1;
	*_uI_1a0= _uI_1aa;
}

void Usagefile_1bf::operator()( const Packets_t& usageInformations_1c0, const Packets_t& configurations_1c3, Packets_t& usageInformations_1c2, Packets_t& fileTypes_1c5)
{
#ifdef PRINT_INFO
	std::cout << "Usagefile_1bf" << std::endl;
#endif
	_usageInformation_1c6= &usageInformations_1c2;
	_fileType_1c7= &fileTypes_1c5;
	processInputPackets( usageInformations_1c0, configurations_1c3);
}

bool Usagefile_1bf::isInputUnique( const Udm::Object& usageInformation_1cc, const Udm::Object& configuration_1d5)
{
	bool isUnique= true;
	for( Packets_t::const_iterator itUsageInformation_1ce= _usageInformation_1c8.begin(), itConfiguration_1d7= _configuration_1d1.begin(); itUsageInformation_1ce!= _usageInformation_1c8.end(), itConfiguration_1d7!= _configuration_1d1.end(); ++itUsageInformation_1ce, ++itConfiguration_1d7)
	{
		if( ( *itUsageInformation_1ce== usageInformation_1cc)&& ( *itConfiguration_1d7== configuration_1d5))
		{
			isUnique= false;
			break;
		}
	}
	if( isUnique)
	{
		_usageInformation_1c8.push_back( usageInformation_1cc);
		_configuration_1d1.push_back( configuration_1d5);
	}
	return isUnique;
}

void Usagefile_1bf::processInputPackets( const Packets_t& usageInformations_1c0, const Packets_t& configurations_1c3)
{
	for( Packets_t::const_iterator itUsageInformation_1c9= usageInformations_1c0.begin(), itConfiguration_1d2= configurations_1c3.begin(); itUsageInformation_1c9!= usageInformations_1c0.end(), itConfiguration_1d2!= configurations_1c3.end(); ++itUsageInformation_1c9, ++itConfiguration_1d2)
	{
		bool isUnique= isInputUnique( *itUsageInformation_1c9, *itConfiguration_1d2);
		if( !isUnique)
			continue;
		bool isMatch= patternMatcher( *itUsageInformation_1c9, *itConfiguration_1d2);
		if( isMatch)
			effector( );
		_matches.clear();
	}
}

bool Usagefile_1bf::patternMatcher( const Udm::Object& usageInformation_1ca, const Udm::Object& configuration_1d3)
{
	for( int i= 0; i< 1; ++i)
	{
		if( false== Uml::IsDerivedFrom( usageInformation_1ca.type(), GReATConfig::UsageInformation::meta))
			continue;
		GReATConfig::UsageInformation usageInformation_1cf= GReATConfig::UsageInformation::Cast( usageInformation_1ca);
		if( false== Uml::IsDerivedFrom( configuration_1d3.type(), UMLModelTransformer::Configuration::meta))
			continue;
		UMLModelTransformer::Configuration configuration_1d8= UMLModelTransformer::Configuration::Cast( configuration_1d3);
		set< UMLModelTransformer::FileType> fileTypes_1da= configuration_1d8.FileType_kind_children();
		for( set< UMLModelTransformer::FileType>::const_iterator itFileType_1db= fileTypes_1da.begin(); itFileType_1db!= fileTypes_1da.end(); ++itFileType_1db)
		{
			UMLModelTransformer::FileType currFileType_1dc= *itFileType_1db;
			Match currMatch;
			currMatch.usageInformation_1dd= usageInformation_1cf;
			currMatch.configuration_1de= configuration_1d8;
			currMatch.fileType_1df= currFileType_1dc;
			_matches.push_back( currMatch);
		}
	}
	return !_matches.empty();
}

void Usagefile_1bf::effector()
{
	for( std::list< Match>::const_iterator itMatch= _matches.begin(); itMatch!= _matches.end(); ++itMatch)
	{
		Match currMatch= *itMatch;
		GReATConfig::FileUsage newFileUsage_1e0= GReATConfig::FileUsage::Create( currMatch.usageInformation_1dd);
		Udm::Object& Configuration= currMatch.configuration_1de;
		Udm::Object& FileType= currMatch.fileType_1df;
		Udm::Object& FileUsage= newFileUsage_1e0;
		Udm::Object& UsageInformation= currMatch.usageInformation_1dd;
		{bool runMem= false; FileType.GetBoolVal("RunInMemory",runMem); FileUsage.SetBoolVal("RunInMemory", runMem); cint_string t1(255); FileType.GetStrVal("MetaName", t1); FileUsage.SetStrVal("MetaName", t1); FileType.GetStrVal("RootClassName", t1); FileUsage.SetStrVal("RootClassName", t1); FileType.GetStrVal("DtdFilePath", t1); FileUsage.SetStrVal("DTDFileName", t1); FileType.GetStrVal("name", t1); FileUsage.SetStrVal("FileID", t1); FileUsage.SetStrVal("name", t1); FileType.GetStrVal("Mode", t1); if(t1.comp("read")==0) {   FileUsage.SetStrVal("Mode","r"); } else if(t1.comp("write")==0) {   FileUsage.SetStrVal("Mode", "w"); } else if(t1.comp("read and write")==0) {   FileUsage.SetStrVal("Mode", "rw"); } else if(t1.comp("read and write to a copy")==0) {   FileUsage.SetStrVal("Mode", "rwc"); }};
		outputAppender( currMatch.usageInformation_1dd, currMatch.fileType_1df);
	}
}

void Usagefile_1bf::outputAppender( const GReATConfig::UsageInformation& usageInformation_1e1, const UMLModelTransformer::FileType& fileType_1e3)
{
	_usageInformation_1c6->push_back( usageInformation_1e1);
	_fileType_1c7->push_back( fileType_1e3);
}

void TransformationInput_1e5::operator()( const Packets_t& usageInformations_1e6, const Packets_t& fileTypes_1e8)
{
#ifdef PRINT_INFO
	std::cout << "TransformationInput_1e5" << std::endl;
#endif
	processInputPackets( usageInformations_1e6, fileTypes_1e8);
}

bool TransformationInput_1e5::isInputUnique( const Udm::Object& usageInformation_1ee, const Udm::Object& fileType_1f7)
{
	bool isUnique= true;
	for( Packets_t::const_iterator itUsageInformation_1f0= _usageInformation_1ea.begin(), itFileType_1f9= _fileType_1f3.begin(); itUsageInformation_1f0!= _usageInformation_1ea.end(), itFileType_1f9!= _fileType_1f3.end(); ++itUsageInformation_1f0, ++itFileType_1f9)
	{
		if( ( *itUsageInformation_1f0== usageInformation_1ee)&& ( *itFileType_1f9== fileType_1f7))
		{
			isUnique= false;
			break;
		}
	}
	if( isUnique)
	{
		_usageInformation_1ea.push_back( usageInformation_1ee);
		_fileType_1f3.push_back( fileType_1f7);
	}
	return isUnique;
}

void TransformationInput_1e5::processInputPackets( const Packets_t& usageInformations_1e6, const Packets_t& fileTypes_1e8)
{
	for( Packets_t::const_iterator itUsageInformation_1eb= usageInformations_1e6.begin(), itFileType_1f4= fileTypes_1e8.begin(); itUsageInformation_1eb!= usageInformations_1e6.end(), itFileType_1f4!= fileTypes_1e8.end(); ++itUsageInformation_1eb, ++itFileType_1f4)
	{
		bool isUnique= isInputUnique( *itUsageInformation_1eb, *itFileType_1f4);
		if( !isUnique)
			continue;
		bool isMatch= patternMatcher( *itUsageInformation_1eb, *itFileType_1f4);
		if( isMatch)
			effector( );
		_matches.clear();
	}
}

bool TransformationInput_1e5::patternMatcher( const Udm::Object& usageInformation_1ec, const Udm::Object& fileType_1f5)
{
	for( int i= 0; i< 1; ++i)
	{
		if( false== Uml::IsDerivedFrom( usageInformation_1ec.type(), GReATConfig::UsageInformation::meta))
			continue;
		GReATConfig::UsageInformation usageInformation_1f1= GReATConfig::UsageInformation::Cast( usageInformation_1ec);
		if( false== Uml::IsDerivedFrom( fileType_1f5.type(), UMLModelTransformer::FileType::meta))
			continue;
		UMLModelTransformer::FileType fileType_1fa= UMLModelTransformer::FileType::Cast( fileType_1f5);
		set< UMLModelTransformer::FileObject> bObjects_1fc= fileType_1fa.FileObject_kind_children();
		for( set< UMLModelTransformer::FileObject>::const_iterator itBObject_1fd= bObjects_1fc.begin(); itBObject_1fd!= bObjects_1fc.end(); ++itBObject_1fd)
		{
			UMLModelTransformer::FileObject currBObject_1fe= *itBObject_1fd;
			set< UMLModelTransformer::TransformationInput> transformationInputs_1ff= currBObject_1fe.dstTransformationInput();
			for( set< UMLModelTransformer::TransformationInput>::const_iterator itTransformationInputs_200= transformationInputs_1ff.begin(); itTransformationInputs_200!= transformationInputs_1ff.end(); ++itTransformationInputs_200)
			{
				UMLModelTransformer::TransformationInput currTransformationInputPseudo_201_202= *itTransformationInputs_200;
				UMLModelTransformer::In in_203= currTransformationInputPseudo_201_202.dstTransformationInput_end();
				Udm::Object inParent_204= in_203.container();
				if( false== Uml::IsDerivedFrom( inParent_204.type(), UMLModelTransformer::Expression::meta))
					continue;
				UMLModelTransformer::Expression expressionIn_205= UMLModelTransformer::Expression::Cast( inParent_204);
				set< UMLModelTransformer::StartRule> startRules_206= expressionIn_205.referedbyStartRule();
				for( set< UMLModelTransformer::StartRule>::const_iterator itStartRules_207= startRules_206.begin(); itStartRules_207!= startRules_206.end(); ++itStartRules_207)
				{
					UMLModelTransformer::StartRule currStartRule_208= *itStartRules_207;
					Match currMatch;
					currMatch.startRule_209= currStartRule_208;
					currMatch.usageInformation_20a= usageInformation_1f1;
					currMatch.fileType_20b= fileType_1fa;
					currMatch.expression_20c= expressionIn_205;
					currMatch.bObject_20d= currBObject_1fe;
					currMatch.in_20e= in_203;
					currMatch.transformationInputPseudo_201_20f= currTransformationInputPseudo_201_202;
					_matches.push_back( currMatch);
				}
			}
		}
	}
	return !_matches.empty();
}

void TransformationInput_1e5::effector()
{
	for( std::list< Match>::const_iterator itMatch= _matches.begin(); itMatch!= _matches.end(); ++itMatch)
	{
		Match currMatch= *itMatch;
		GReATConfig::TransformationInput newTransformationInput_210= GReATConfig::TransformationInput::Create( currMatch.usageInformation_20a);
		Udm::Object& BObject= currMatch.bObject_20d;
		Udm::Object& Expression= currMatch.expression_20c;
		Udm::Object& FileType= currMatch.fileType_20b;
		Udm::Object& In= currMatch.in_20e;
		Udm::Object& StartRule= currMatch.startRule_209;
		Udm::Object& TransformationInput= newTransformationInput_210;
		Udm::Object& TransformationInputPseudo_201= currMatch.transformationInputPseudo_201_20f;
		Udm::Object& UsageInformation= currMatch.usageInformation_20a;
		{cint_string t1(255); In.GetStrVal("name", t1); TransformationInput.SetStrVal("PortName", t1); BObject.GetStrVal("ObjectPath", t1); TransformationInput.SetStrVal("ObjectPath", t1); FileType.GetStrVal("name", t1); TransformationInput.SetStrVal("FileID", t1); t1 += "_PortMapping"; TransformationInput.SetStrVal("name", t1);};
		outputAppender( );
	}
}

void TransformationInput_1e5::outputAppender()
{
}

