#include <UdmBase.h>
#include <cint_string.h>
#include "GReATConfig.h"
#include "UMLModelTransformer.h"
//#include "UMT2Config.h"

typedef std::list< Udm::Object> Packets_t;

// Forward declarations.
class UMT2Config_0;
class Init_13;
class UserCodeLibraryAttrs_37;
class MetaInfo_5c;
class RunTimeInfo_85;
class UserCodeLibrary_ae;
class UsageInfo_d8;
class UsageInfo_e1;
class GetPath_110;
class Test_115;
class RuleCompound_12c;
class TestCompound_150;
class CompoundCompound_174;
class StartRulePath_198;
class Usagefile_1bf;
class TransformationInput_1e5;

// Class declarations.
class UMT2Config_0
{
public:
	void operator()( const Packets_t& confRFs_1, const Packets_t& umtConfigmodels_3);

protected:
	void executeOne( const Packets_t& confRFs_1, const Packets_t& umtConfigmodels_3);
	bool isInputUnique( const Udm::Object& confRF_7, const Udm::Object& umtConfigmodel_e);
	void callInit_21d( const Packets_t& rootFolders_14, const Packets_t& configurations_17);
	void callMetaInfo_220( const Packets_t& rootFolders_5d, const Packets_t& configurations_60);
	void callUserCodeLibrary_223( const Packets_t& rootFolders_af, const Packets_t& configurations_b2);
	void callUsageInfo_226( const Packets_t& confRFs_d9, const Packets_t& umtConfigmodels_db);
	void callUserCodeLibraryAttrs_229( const Packets_t& rootFolders_38, const Packets_t& configurations_3a);
	void callRunTimeInfo_22c( const Packets_t& rootFolders_86, const Packets_t& configurations_88);

private:
	Packets_t _confRF_5;
	Packets_t _umtConfigmodel_c;
};

class Init_13
{
public:
	void operator()( const Packets_t& rootFolders_14, const Packets_t& configurations_17, Packets_t& rootFolders_16, Packets_t& configurations_19);

protected:
	bool isInputUnique( const Udm::Object& rootFolder_20, const Udm::Object& configuration_29);
	void processInputPackets( const Packets_t& rootFolders_14, const Packets_t& configurations_17);
	bool patternMatcher( const Udm::Object& rootFolder_1e, const Udm::Object& configuration_27);
	void effector();
	void outputAppender( const GReATConfig::RootFolder& rootFolder_33, const UMLModelTransformer::Configuration& configuration_35);
	void forwardInputs();

private:
	Packets_t* _rootFolder_1a;
	Packets_t* _configuration_1b;
	Packets_t _rootFolder_1c;
	Packets_t _configuration_25;
	class Match
	{
	public:
		GReATConfig::RootFolder rootFolder_2e;
		UMLModelTransformer::Configuration configuration_2f;
	};

	std::list< Match> _matches;
};

class UserCodeLibraryAttrs_37
{
public:
	void operator()( const Packets_t& rootFolders_38, const Packets_t& configurations_3a);

protected:
	bool isInputUnique( const Udm::Object& rootFolder_40, const Udm::Object& configuration_49);
	void processInputPackets( const Packets_t& rootFolders_38, const Packets_t& configurations_3a);
	bool patternMatcher( const Udm::Object& rootFolder_3e, const Udm::Object& configuration_47);
	void effector();
	void outputAppender();

private:
	Packets_t _rootFolder_3c;
	Packets_t _configuration_45;
	class Match
	{
	public:
		GReATConfig::RootFolder rootFolder_57;
		UMLModelTransformer::Configuration configuration_58;
		UMLModelTransformer::UserCodeLibrary umtUCL_59;
		GReATConfig::MetaInformation metaInformation_5a;
		GReATConfig::UserCode confUCL_5b;
	};

	std::list< Match> _matches;
};

class MetaInfo_5c
{
public:
	void operator()( const Packets_t& rootFolders_5d, const Packets_t& configurations_60, Packets_t& rootFolders_5f, Packets_t& configurations_62);

protected:
	bool isInputUnique( const Udm::Object& rootFolder_69, const Udm::Object& configuration_72);
	void processInputPackets( const Packets_t& rootFolders_5d, const Packets_t& configurations_60);
	bool patternMatcher( const Udm::Object& rootFolder_67, const Udm::Object& configuration_70);
	void effector();
	void outputAppender( const GReATConfig::RootFolder& rootFolder_81, const UMLModelTransformer::Configuration& configuration_83);
	void forwardInputs();

private:
	Packets_t* _rootFolder_63;
	Packets_t* _configuration_64;
	Packets_t _rootFolder_65;
	Packets_t _configuration_6e;
	class Match
	{
	public:
		GReATConfig::RootFolder rootFolder_7d;
		UMLModelTransformer::Configuration configuration_7e;
		UMLModelTransformer::MetaInformation mIF_7f;
		GReATConfig::MetaInformation cMIF_80;
	};

	std::list< Match> _matches;
};

class RunTimeInfo_85
{
public:
	void operator()( const Packets_t& rootFolders_86, const Packets_t& configurations_88);

protected:
	bool isInputUnique( const Udm::Object& rootFolder_8e, const Udm::Object& configuration_97);
	void processInputPackets( const Packets_t& rootFolders_86, const Packets_t& configurations_88);
	bool patternMatcher( const Udm::Object& rootFolder_8c, const Udm::Object& configuration_95);
	void effector();
	void outputAppender();

private:
	Packets_t _rootFolder_8a;
	Packets_t _configuration_93;
	class Match
	{
	public:
		GReATConfig::RootFolder rootFolder_a7;
		UMLModelTransformer::Configuration configuration_a8;
		UMLModelTransformer::FileType fileType_a9;
		GReATConfig::RuntimeInformation runtimeInformation_aa;
		UMLModelTransformer::File file_ab;
		UMLModelTransformer::FileBind fileBindPseudo_a4_ac;
	};

	std::list< Match> _matches;
};

class UserCodeLibrary_ae
{
public:
	void operator()( const Packets_t& rootFolders_af, const Packets_t& configurations_b2, Packets_t& rootFolders_b1, Packets_t& configurations_b4);

protected:
	bool isInputUnique( const Udm::Object& rootFolder_bb, const Udm::Object& configuration_c4);
	void processInputPackets( const Packets_t& rootFolders_af, const Packets_t& configurations_b2);
	bool patternMatcher( const Udm::Object& rootFolder_b9, const Udm::Object& configuration_c2);
	void effector();
	void outputAppender( const GReATConfig::RootFolder& rootFolder_d4, const UMLModelTransformer::Configuration& configuration_d6);
	void forwardInputs();

private:
	Packets_t* _rootFolder_b5;
	Packets_t* _configuration_b6;
	Packets_t _rootFolder_b7;
	Packets_t _configuration_c0;
	class Match
	{
	public:
		GReATConfig::RootFolder rootFolder_cf;
		UMLModelTransformer::Configuration configuration_d0;
		UMLModelTransformer::UserCodeLibrary userCodeLibrary_d1;
		GReATConfig::MetaInformation metaInformation_d2;
	};

	std::list< Match> _matches;
};

class UsageInfo_d8
{
public:
	void operator()( const Packets_t& confRFs_d9, const Packets_t& umtConfigmodels_db, Packets_t& outs_dd, Packets_t& outs_de);

protected:
	void callUsageInfo_211( const Packets_t& rootFolders_e2, const Packets_t& configurations_e4);
	void callGetPath_214( const Packets_t& ins_111, const Packets_t& ins_113);
	void callUsagefile_217( const Packets_t& usageInformations_1c0, const Packets_t& configurations_1c3);
	void callTransformationInput_21a( const Packets_t& usageInformations_1e6, const Packets_t& fileTypes_1e8);

private:
	Packets_t* _out_df;
	Packets_t* _out_e0;
};

class UsageInfo_e1
{
public:
	void operator()( const Packets_t& rootFolders_e2, const Packets_t& configurations_e4, Packets_t& configurations_e6, Packets_t& uIs_e7, Packets_t& expressions_e8);

protected:
	bool isInputUnique( const Udm::Object& rootFolder_f0, const Udm::Object& configuration_f9);
	void processInputPackets( const Packets_t& rootFolders_e2, const Packets_t& configurations_e4);
	bool patternMatcher( const Udm::Object& rootFolder_ee, const Udm::Object& configuration_f7);
	void effector();
	void outputAppender( const UMLModelTransformer::Configuration& configuration_10a, const GReATConfig::UsageInformation& uI_10c, const UMLModelTransformer::Expression& expression_10e);

private:
	Packets_t* _configuration_e9;
	Packets_t* _uI_ea;
	Packets_t* _expression_eb;
	Packets_t _rootFolder_ec;
	Packets_t _configuration_f5;
	class Match
	{
	public:
		GReATConfig::RootFolder rootFolder_105;
		UMLModelTransformer::Configuration configuration_106;
		GReATConfig::UsageInformation uI_107;
		UMLModelTransformer::StartRule startRule_108;
		UMLModelTransformer::Expression expression_109;
	};

	std::list< Match> _matches;
};

class GetPath_110
{
public:
	void operator()( const Packets_t& ins_111, const Packets_t& ins_113);

protected:
	void callTest_1b9( const Packets_t& ins_116, const Packets_t& ins_118);
	void callStartRulePath_1bc( const Packets_t& parents_199, const Packets_t& uIs_19c);
};

class Test_115
{
public:
	void operator()( const Packets_t& ins_116, const Packets_t& ins_118, Packets_t& outs_11a, Packets_t& outs_11b);

protected:
	void executeOne( const Packets_t& ins_116, const Packets_t& ins_118);
	bool isInputUnique( const Udm::Object& in_120, const Udm::Object& in_127);

private:
	Packets_t* _out_11c;
	Packets_t* _out_11d;
	Packets_t _in_11e;
	Packets_t _in_125;
};

class RuleCompound_12c
{
public:
	bool operator()( const Packets_t& childs_12d, const Packets_t& uIs_12f, Packets_t& uIs_131, Packets_t& parents_132);

protected:
	bool isInputUnique( const Udm::Object& child_139, const Udm::Object& uI_142);
	void processInputPackets( const Packets_t& childs_12d, const Packets_t& uIs_12f);
	bool patternMatcher( const Udm::Object& child_137, const Udm::Object& uI_140);
	void outputAppender( const GReATConfig::UsageInformation& uI_14c, const UMLModelTransformer::CompoundRule& parent_14e);

private:
	Packets_t* _uI_133;
	Packets_t* _parent_134;
	Packets_t _child_135;
	Packets_t _uI_13e;
	class Match
	{
	public:
		UMLModelTransformer::Rule child_149;
		GReATConfig::UsageInformation uI_14a;
		UMLModelTransformer::CompoundRule parent_14b;
	};

	std::list< Match> _matches;
};

class TestCompound_150
{
public:
	bool operator()( const Packets_t& childs_151, const Packets_t& uIs_153, Packets_t& uIs_155, Packets_t& parents_156);

protected:
	bool isInputUnique( const Udm::Object& child_15d, const Udm::Object& uI_166);
	void processInputPackets( const Packets_t& childs_151, const Packets_t& uIs_153);
	bool patternMatcher( const Udm::Object& child_15b, const Udm::Object& uI_164);
	void outputAppender( const GReATConfig::UsageInformation& uI_170, const UMLModelTransformer::CompoundRule& parent_172);

private:
	Packets_t* _uI_157;
	Packets_t* _parent_158;
	Packets_t _child_159;
	Packets_t _uI_162;
	class Match
	{
	public:
		UMLModelTransformer::Test child_16d;
		GReATConfig::UsageInformation uI_16e;
		UMLModelTransformer::CompoundRule parent_16f;
	};

	std::list< Match> _matches;
};

class CompoundCompound_174
{
public:
	bool operator()( const Packets_t& childs_175, const Packets_t& uIs_177, Packets_t& uIs_179, Packets_t& parents_17a);

protected:
	bool isInputUnique( const Udm::Object& child_181, const Udm::Object& uI_18a);
	void processInputPackets( const Packets_t& childs_175, const Packets_t& uIs_177);
	bool patternMatcher( const Udm::Object& child_17f, const Udm::Object& uI_188);
	void outputAppender( const GReATConfig::UsageInformation& uI_194, const UMLModelTransformer::CompoundRule& parent_196);

private:
	Packets_t* _uI_17b;
	Packets_t* _parent_17c;
	Packets_t _child_17d;
	Packets_t _uI_186;
	class Match
	{
	public:
		UMLModelTransformer::CompoundRule child_191;
		GReATConfig::UsageInformation uI_192;
		UMLModelTransformer::CompoundRule parent_193;
	};

	std::list< Match> _matches;
};

class StartRulePath_198
{
public:
	void operator()( const Packets_t& parents_199, const Packets_t& uIs_19c, Packets_t& parents_19b, Packets_t& uIs_19e);

protected:
	bool isInputUnique( const Udm::Object& parent_1a5, const Udm::Object& uI_1ae);
	void processInputPackets( const Packets_t& parents_199, const Packets_t& uIs_19c);
	bool patternMatcher( const Udm::Object& parent_1a3, const Udm::Object& uI_1ac);
	void effector();
	void outputAppender( const UMLModelTransformer::Expression& parent_1b5, const GReATConfig::UsageInformation& uI_1b7);
	void forwardInputs();

private:
	Packets_t* _parent_19f;
	Packets_t* _uI_1a0;
	Packets_t _parent_1a1;
	Packets_t _uI_1aa;
	class Match
	{
	public:
		UMLModelTransformer::Expression parent_1b3;
		GReATConfig::UsageInformation uI_1b4;
	};

	std::list< Match> _matches;
};

class Usagefile_1bf
{
public:
	void operator()( const Packets_t& usageInformations_1c0, const Packets_t& configurations_1c3, Packets_t& usageInformations_1c2, Packets_t& fileTypes_1c5);

protected:
	bool isInputUnique( const Udm::Object& usageInformation_1cc, const Udm::Object& configuration_1d5);
	void processInputPackets( const Packets_t& usageInformations_1c0, const Packets_t& configurations_1c3);
	bool patternMatcher( const Udm::Object& usageInformation_1ca, const Udm::Object& configuration_1d3);
	void effector();
	void outputAppender( const GReATConfig::UsageInformation& usageInformation_1e1, const UMLModelTransformer::FileType& fileType_1e3);

private:
	Packets_t* _usageInformation_1c6;
	Packets_t* _fileType_1c7;
	Packets_t _usageInformation_1c8;
	Packets_t _configuration_1d1;
	class Match
	{
	public:
		GReATConfig::UsageInformation usageInformation_1dd;
		UMLModelTransformer::Configuration configuration_1de;
		UMLModelTransformer::FileType fileType_1df;
	};

	std::list< Match> _matches;
};

class TransformationInput_1e5
{
public:
	void operator()( const Packets_t& usageInformations_1e6, const Packets_t& fileTypes_1e8);

protected:
	bool isInputUnique( const Udm::Object& usageInformation_1ee, const Udm::Object& fileType_1f7);
	void processInputPackets( const Packets_t& usageInformations_1e6, const Packets_t& fileTypes_1e8);
	bool patternMatcher( const Udm::Object& usageInformation_1ec, const Udm::Object& fileType_1f5);
	void effector();
	void outputAppender();

private:
	Packets_t _usageInformation_1ea;
	Packets_t _fileType_1f3;
	class Match
	{
	public:
		UMLModelTransformer::StartRule startRule_209;
		GReATConfig::UsageInformation usageInformation_20a;
		UMLModelTransformer::FileType fileType_20b;
		UMLModelTransformer::Expression expression_20c;
		UMLModelTransformer::FileObject bObject_20d;
		UMLModelTransformer::In in_20e;
		UMLModelTransformer::TransformationInput transformationInputPseudo_201_20f;
	};

	std::list< Match> _matches;
};

